<?php
/*
///////////////////////////////////////////////////////////////////////////
//  IMPORTANT!
//  You must modify the following line to match the password you set
//  in your WebServicesManager.fp7 database
///////////////////////////////////////////////////////////////////////////
*/

define( 'PASSWORD', 'putyourpasswordhere' ); //Change this to whatever password you set in your FileMaker file
define( 'HOST', '127.0.0.1' ); //Do not edit this without first consulting the support staff at 360Works


/*
///////////////////////////////////////////////////////////////////////////
//  Do not edit anything after this line
///////////////////////////////////////////////////////////////////////////
*/

include 'FileMaker.php';

register_shutdown_function( 'fatalErrorHandler' );

/*
 * Line endings and log locations for Windows/Unix
 */
define ( 'VERSION' , '1.622');
define ( 'IS_WINDOWS' , strtoupper( substr( PHP_OS, 0, 3 ) ) === 'WIN');
//define ( 'PHP_EOL', IS_WINDOWS ? "\r\n" : "\n" );
define ( 'TEMP_DIR', IS_WINDOWS ? sys_get_temp_dir() : "/tmp");
define( 'LOG_LOCATION', join_path(TEMP_DIR, 'websvcmgr.log') );
define( 'REQUEST_LOG_LOCATION', join_path(TEMP_DIR, 'wsmRequest.log') );
define( 'FMXML_PREFIX', '/\/fmi\/xml\/cnt\/.*\.[\w\d]+\?/');

/*
 * INI settings
 */
$memorySet = ini_set( 'memory_limit', '128M' );
$errorSet = ini_set( 'track_errors', TRUE );
$winLogSet = ini_set( 'error_log', LOG_LOCATION );
$zlibCompress = ini_set( 'zlib.output_compression', '1' );
error_reporting( E_ERROR );
date_default_timezone_set( 'US/Eastern' );
set_time_limit( 0 );

session_start();

/*
 * Soap schema to validate SOAP requests
 */
$soapSchema = <<<SOAP_SCHEMA
<?xml version='1.0' encoding='UTF-8' ?>
<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema"
           xmlns:tns="http://schemas.xmlsoap.org/soap/envelope/"
           targetNamespace="http://schemas.xmlsoap.org/soap/envelope/" >

  <xs:element name="Envelope" type="tns:Envelope" />
  <xs:complexType name="Envelope" >
    <xs:sequence>
      <xs:element ref="tns:Header" minOccurs="0" />
      <xs:element ref="tns:Body" minOccurs="1" />

      <xs:any namespace="##other" minOccurs="0" maxOccurs="unbounded" processContents="lax" />
    </xs:sequence>
    <xs:anyAttribute namespace="##other" processContents="lax" />
  </xs:complexType>

  <xs:element name="Header" type="tns:Header" />
  <xs:complexType name="Header" >
    <xs:sequence>
      <xs:any namespace="##other" minOccurs="0" maxOccurs="unbounded" processContents="lax" />

    </xs:sequence>
    <xs:anyAttribute namespace="##other" processContents="lax" />
  </xs:complexType>
  
  <xs:element name="Body" type="tns:Body" />
  <xs:complexType name="Body" >
    <xs:sequence>
      <xs:any namespace="##any" minOccurs="0" maxOccurs="unbounded" processContents="lax" />
    </xs:sequence>
    <xs:anyAttribute namespace="##any" processContents="lax" >

	  <xs:annotation>
	    <xs:documentation>
		  Prose in the spec does not specify that attributes are allowed on the Body element
		</xs:documentation>
	  </xs:annotation>
	</xs:anyAttribute>
  </xs:complexType>

  <xs:attribute name="mustUnderstand" >	
     <xs:simpleType>

     <xs:restriction base='xs:boolean'>
	   <xs:pattern value='0|1' />
	 </xs:restriction>
   </xs:simpleType>
  </xs:attribute>
  <xs:attribute name="actor" type="xs:anyURI" />

  <xs:simpleType name="encodingStyle" >
    <xs:annotation>

	  <xs:documentation>
	    'encodingStyle' indicates any canonicalization conventions followed in the contents of the containing element.  For example, the value 'http://schemas.xmlsoap.org/soap/encoding/' indicates the pattern described in SOAP specification
	  </xs:documentation>
	</xs:annotation>
    <xs:list itemType="xs:anyURI" />
  </xs:simpleType>

  <xs:attribute name="encodingStyle" type="tns:encodingStyle" />
  <xs:attributeGroup name="encodingStyle" >
    <xs:attribute ref="tns:encodingStyle" />

  </xs:attributeGroup>

  <xs:element name="Fault" type="tns:Fault" />
  <xs:complexType name="Fault" final="extension" >
    <xs:annotation>
	  <xs:documentation>
	    Fault reporting structure
	  </xs:documentation>
	</xs:annotation>
    <xs:sequence>

      <xs:element name="faultcode" type="xs:QName" />
      <xs:element name="faultstring" type="xs:string" />
      <xs:element name="faultactor" type="xs:anyURI" minOccurs="0" />
      <xs:element name="detail" type="tns:detail" minOccurs="0" />      
    </xs:sequence>
  </xs:complexType>

  <xs:complexType name="detail">
    <xs:sequence>
      <xs:any namespace="##any" minOccurs="0" maxOccurs="unbounded" processContents="lax" />

    </xs:sequence>
    <xs:anyAttribute namespace="##any" processContents="lax" /> 
  </xs:complexType>

</xs:schema>
SOAP_SCHEMA;

//include 'FileMaker.php';

/***********************WEB SERVICES MANAGER CONSTANTS***********************/

define( 'SERVER_PORT', $_SERVER ['SERVER_PORT'] == '80' ? '' : ':' . $_SERVER ['SERVER_PORT'] );

/**
 * Name of FileMaker Web Services Manager database
 */
define( 'WEB_SVCS_MGR_DBNAME', 'Web Services Manager' );

/***********************NAMESPACE CONSTANTS***********************/

define( 'NS_URL', "http://{$_SERVER['SERVER_NAME']}" );
define( 'BASE_URL', "http://{$_SERVER['SERVER_NAME']}" . SERVER_PORT );
define( 'SCRIPT_URL', "http://{$_SERVER['SERVER_NAME']}/fmi/xml/fmresultset.xml" );

/**
 * XML schema namespace
 */
define( 'XMLNS_XSD', 'http://www.w3.org/2001/XMLSchema' );

/**
 * XML schema instance namespace
 */
define( 'XMLNS_XSI', 'http://www.w3.org/2001/XMLSchema-instance' );

/**
 * XML wsdl namespace
 */
define( 'XMLNS_WSDL', 'http://schemas.xmlsoap.org/wsdl/' );

/**
 * XML soap namespace
 */
define( 'XMLNS_SOAP', 'http://schemas.xmlsoap.org/wsdl/soap/' );

/**
 * XML http namespace
 */
//define ( 'XMLNS_HTTP', 'http://schemas.xmlsoap.org/wsdl/http/' );
define( 'XMLNS_HTTP', 'http://schemas.xmlsoap.org/soap/http' );

/**
 * XML soap envelope namespace
 */
define( 'XMLNS_ENVELOPE', 'http://schemas.xmlsoap.org/soap/envelope/' );

/**
 * XML namespace
 */
define( 'NAMESPACE_URI', 'http://www.w3.org/2000/xmlns/' );

/***********************START OF WSDL-GENERATING CLASSES***********************/

class WSDL extends SimpleElement {

    public function __construct($targetNamespace, $docs = NULL) {

        $definitionsAttributes = array (
            'targetNamespace' => $targetNamespace,
            'xmlns:tns' => $targetNamespace,
            'xmlns:wsdl' => XMLNS_WSDL,
            'xmlns:soap' => XMLNS_SOAP,
            'xmlns:http' => XMLNS_HTTP,
            'xmlns:xsd' => XMLNS_XSD
        );
        parent::__construct( 'definitions', $definitionsAttributes, XMLNS_WSDL );
        if (isset( $docs )) {
            $docsElement = $this->createElement( 'documentation' );
            $this->root->appendChild( $docsElement );
            $docsElement->appendChild( $this->createTextNode( self::formatXMLContent( $docs ) ) );
        }
    }
}

class SimpleElement extends DOMDocument {

    /**
     * Definitions WSDL root
     *
     * @var DOMElement
     */
    protected $root;

    public function __set($name, $value) {

        $this->root->setAttribute( $name, $value );
    }

    public function __get($name) {

        $returnValue = NULL;
        $elementList = $this->getElementsByTagName( $name );
        $length = $elementList->length;
        if ($length > 0) {
            if ($length == 1) {
                $returnValue = $elementList->item( 0 );
            } else {
                $returnValue = $elementList;
            }
        }
        return $returnValue;
    }

    public function __construct($tagName, $attributes = NULL, $ns = NULL, $value = NULL) {

        parent::__construct( '1.0', 'utf-8' );
        if (isset( $ns )) {
            $this->root = $this->createElementNS( $ns, $tagName, $value );
        } else {
            $this->root = $this->createElement( $tagName, $value );
        }
        if (isset( $attributes )) {
            foreach ( $attributes as $name => $value ) {
                if (isset( $value )) {
                    $this->{$name} = $value;
                }
            }
        }
        $this->appendChild( $this->root );
    }

    /**
     * Returns the root root
     *
     * @return DOMElement
     */
    public function getRoot() {

        $returnValue = FALSE;
        if ($this->hasChildNodes()) {
            $returnValue = $this->documentElement;
        }
        return $returnValue;
    }

    /**
     * Returns the root root's tag name
     *
     * @return string
     */
    public function getTagName() {

        return $this->root->nodeName;
    }

    /**
     * Writes the root as an XML-formatted string
     *
     */
    public function write() {

        header( 'Content-type:text/xml', TRUE );
        $this->formatOutput = TRUE;
        $this->preserveWhiteSpace = TRUE; //TODO Not sure if this is a good idea --svr
        if (!$xmlOutput = $this->saveXML()) {
            $lastXMLError = libxml_get_last_error();
            throw new DOMException( "An error occurred while trying to generate the WSDL file: " . $lastXMLError->message );
        }
        echo $xmlOutput;
    }

    public static function formatXMLContent($text) {

        return htmlspecialchars( $text, ENT_QUOTES, 'utf-8', true);
    }

    public static function formatXMLTag($textToStrip) {

        $textToStrip = ucwords( $textToStrip );

        if (preg_match( "/^\\d+.*/", $textToStrip )) {
            $textToStrip = "x_" . $textToStrip;
        }
        if (preg_match( "/[^\\w\\d\\.:-]+/", $textToStrip )) {
            $splitArray = preg_split( "/[^\\w\\d\\.:-]+/", $textToStrip );
            $textToStrip = join( "", $splitArray );
        }
        $replaceArray = str_replace( ':', '_', $textToStrip );

        return $replaceArray;
    }

    public function addChildDoc(DOMNode $child) {

        if ($child instanceof SimpleElement) {
            $importChild = $this->importNode( $child->getRoot(), TRUE );
        } else {
            $importChild = $this->importNode( $child, TRUE );
        }
        $this->root->appendChild( $importChild );
    }

}

class ComplexType extends SimpleElement {

    /**
     * @var SimpleElement
     */
    private $sequence;

    /**
     * @return SimpleElement
     */
    public function getSequence() {

        return $this->sequence;
    }

    /**
     *
     * @param string $name
     *  Represents the name attribute of this complex type
     * @param unknown $arrayOfElements
     *  Represents an array of XML elements in a sequence and each element's attributes
     */
    public function __construct($name, $arrayOfElements = NULL) {

        if (isset( $name )) {
            $nameArray ['name'] = $name;
        } else {
            $nameArray = $name;
        }
        parent::__construct( 'complexType', $nameArray );
        if (isset( $arrayOfElements )) {
            $this->sequence = new SimpleElement( 'sequence' );
            if (isset( $arrayOfElements )) {
                foreach ( $arrayOfElements as $element ) {
                    $newChildElement = new SimpleElement( 'element', $element );
                    $this->sequence->addChildDoc( $newChildElement );
                }
            }
            $this->addChildDoc( $this->sequence );
        }
    }

    function addChildElement(SimpleElement $element) {

        $this->getSequence()->addChildDoc( $element );
    }
}

class ElementAndComplexType extends SimpleElement {

    /**
     * The complexType child node for this element
     *
     * @var ComplexType
     */
    private $complexType;

    public function __construct($name, $arrayOfElements = NULL) {

        if (isset( $name )) {
            $nameArray ['name'] = $name;
        } else {
            $nameArray = $name;
        }
        parent::__construct( 'element', $nameArray );
        $newComplexType = new ComplexType( NULL, $arrayOfElements );
        $this->addChildDoc( $newComplexType );
    }
}

class MySchema extends SimpleElement {

    const xmlns = XMLNS_XSD;

    const elementFormDefault = 'qualified';

    public function __construct($ns, $prefix) {

        $arrayOfAttributes = array (
            'xmlns' => self::xmlns,
            "elementFormDefault" => self::elementFormDefault,
            "targetNamespace" => $ns
        );
        parent::__construct( 'schema', $arrayOfAttributes );
    }
}

class Message extends SimpleElement {

    const REQUEST = 2;

    const RESPONSE = 4;

    const AUTHENTICATION = 8;

    const FAULT = 16;

    /**
     * Determines whether a message is used for authentication or basic request/response
     *
     * @var int
     */
    protected $msgType;

    public function __construct($messageName, $prefix, $elementName = NULL, $elementPrefix = NULL) {

        if (!empty( $prefix ))
            $prefix = $prefix . ':';

        if (!empty( $elementPrefix ))
            $elementPrefix = $elementPrefix . ':';

        parent::__construct( 'message', array (
            'name' => $messageName
        ) );

        $prefixAndElement = ($elementName != NULL || $elementPrefix != null) ? $elementPrefix . $elementName : $prefix . $messageName;
        switch ($this->msgType) {
            case self::REQUEST :
                $partAttributes = array (
                    'name' => 'parameters',
                    'element' => $prefixAndElement
                );
                $partElement = new SimpleElement( 'part', $partAttributes );
                break;
            case self::RESPONSE :
                //Apparently the parts should be named 'parameters' for the response as well as the results.
                //At least this is true for calling from Flash - this will make it so that it ignores the topmost layer, which is just a wrapper.--jsb
                //$partAttributes = array ('name' => 'results', 'element' => $prefix . $messageName );
                $partAttributes = array (
                    'name' => 'parameters',
                    'element' => $prefixAndElement
                );
                $partElement = new SimpleElement( 'part', $partAttributes );
                break;
            case self::AUTHENTICATION :
                $partAttributes = array (
                    'name' => 'login',
                    'element' => $prefixAndElement
                );
                $partElement = new SimpleElement( 'part', $partAttributes );
                break;
            case self::FAULT :
                $partAttributes = array (
                    'name' => 'faultDetail',
                    'type' => 'xsd:string'
                );
                $partElement = new SimpleElement( 'part', $partAttributes );
                break;
        }
        $this->addChildDoc( $partElement->getRoot() );
    }
}

class RequestMessage extends Message {

    public function __construct($messageName, $prefix, $elementName = NULL, $elementPrefix = NULL) {

        $this->msgType = self::REQUEST;
        parent::__construct( $messageName, $prefix, $elementName, $elementPrefix );
    }
}

class ResponseMessage extends Message {

    public function __construct($messageName, $prefix) {

        $this->msgType = self::RESPONSE;
        parent::__construct( $messageName, $prefix );
    }
}

class AuthenticationMessage extends Message {

    public function __construct($messageName, $prefix) {

        $this->msgType = self::AUTHENTICATION;
        parent::__construct( $messageName, $prefix );
    }
}

class FaultMessage extends Message {

    public function __construct($messageName, $prefix) {

        $this->msgType = self::AUTHENTICATION;
        parent::__construct( $messageName, $prefix );
    }
}

class PortType extends SimpleElement {

    public function __construct($name, $docs = NULL) {

        parent::__construct( 'portType', array (
            'name' => $name
        ) );
        if (isset( $docs )) {
            $docsElement = $this->createElement( 'documentation' );
            $docsElement->appendChild( $this->createTextNode( WSDL::formatXMLContent( $docs ) ) );
            $this->documentElement->appendChild( $docsElement );
        }
    }

}

class PortTypeOperation extends SimpleElement {

    public function __construct($opName, $prefix, $docs = NULL) {

        parent::__construct( 'operation', array (
            'name' => $opName
        ) );
        if (isset( $docs )) {
            $docsElement = $this->createElement( 'documentation' );
            $docsElement->appendChild( $this->createTextNode( WSDL::formatXMLContent( $docs ) ) );
            $this->documentElement->appendChild( $docsElement );
        }
        $this->addMessages( $opName, $prefix );
    }

    public function addMessages($opName, $prefix, $faultMsg = NULL) {

        if (!empty( $prefix ))
            $prefix = $prefix . ':';

        $inputMsg = new SimpleElement( 'input', array (
            'message' => 'tns:' . $opName
        ) );
        $this->addChildDoc( $inputMsg );

        $outputMsg = new SimpleElement( 'output', array (
            'message' => 'tns:' . "$opName" . 'Response'
        ) );
        $this->addChildDoc( $outputMsg );

        if (isset( $faultMsg )) {
            $faultMsg = new SimpleElement( 'fault', array (
                'name' => 'fault',
                'm'
            ) );
            $this->addChildDoc( $faultMsg );
        }

    }
}

class Binding extends SimpleElement {

    public function __construct($name, $prefix = NULL, $docs = NULL) {

        if (!empty( $prefix ))
            $prefix = $prefix . ':';

        parent::__construct( 'binding', array (
            'name' => $name,
            'type' => $prefix . $name
        ) );
        if (isset( $docs )) {
            $docsElement = $this->createElement( 'documentation' );
            $docsElement->appendChild( $this->createTextNode( WSDL::formatXMLContent( $docs ) ) );
            $this->documentElement->appendChild( $docsElement );
        }
        $soapBindingAttributes = array (
            'transport' => XMLNS_HTTP
        );
        $soapBinding = new SimpleElement( 'soap:binding', $soapBindingAttributes );
        $soapBinding->{"xmlns:soap"} = XMLNS_SOAP;
        $this->addChildDoc( $soapBinding );
    }

}

class BindingOperation extends SimpleElement {

    public function __construct($opName, $authRequired = NULL, $authMsgName = NULL, $prefix = NULL, $actionURI = NULL, $faultName = NULL) {

        parent::__construct( 'operation', array (
            'name' => $opName
        ) );
        $this->addSoapOperation( $actionURI );
        $this->addInput( $prefix, $authRequired, $authMsgName );
        $this->addOutput();
        $this->addFault( $faultName );
    }

    public function addSoapOperation($actionURI) {

        if ($actionURI === NULL) {
            $soapOpAttributes ['soapAction'] = $actionURI;
        } else {
            $soapOpAttributes = NULL;
        }
        $soapOpAttributes ['style'] = 'document';
        $soapOp = new SimpleElement( 'soap:operation', $soapOpAttributes );
        $soapOp->{"xmlns:soap"} = XMLNS_SOAP;
        $this->addChildDoc( $soapOp );
    }

    public function addInput($prefix = NULL, $authRequired = NULL, $authMsgName = NULL) {

        if (!empty( $prefix ))
            $prefix = $prefix . ':';

        $input = new SimpleElement( 'input' );
        $bodyAttributes = array (
            'use' => 'literal'
        );
        $body = new SimpleElement( 'soap:body', $bodyAttributes, XMLNS_SOAP );
        $input->addChildDoc( $body );

        if ($authRequired && !empty( $authMsgName )) {
            $headerAttributes = array (
                'message' => $prefix . $authMsgName,
                'part' => 'login',
                'use' => 'literal'
            );
            $header = new SimpleElement( 'soap:header', $headerAttributes, XMLNS_SOAP );
            $input->addChildDoc( $header );
        }
        $this->addChildDoc( $input );

    }

    public function addOutput() {

        $output = new SimpleElement( 'output' );
        $bodyAttributes = array (
            'use' => 'literal'
        );
        $body = new SimpleElement( 'soap:body', $bodyAttributes, XMLNS_SOAP );
        $output->addChildDoc( $body );
        $this->addChildDoc( $output );

    }

    public function addFault($faultName = NULL) {

        if (isset( $faultName )) {
            $fault = new SimpleElement( 'fault' );
            $faultAttributes = array (
                'name' => $faultName,
                'use' => 'literal'
            );
            $soapFault = new SimpleElement( 'soap:fault', $faultAttributes );
            $this->addChildDoc( $fault );
            $fault->addChildDoc( $soapFault );
        }
    }
}

class Service extends SimpleElement {

    public function __construct($serviceName, $docs = NULL) {

        parent::__construct( 'service', array (
            'name' => $serviceName
        ) );
        if (isset( $docs )) {
            $docsElement = $this->createElement( 'documentation' );
            $this->root->appendChild( $docsElement );
            $docsElement->appendChild( $this->createTextNode( self::formatXMLContent( $docs ) ) );
        }
    }

}

class ServicePort extends SimpleElement {

    public function __construct($serviceName, $prefix, $endpointURI) {

        if (!empty( $prefix ))
            $prefix = $prefix . ':';

        $portAttributes = array (
            'name' => $serviceName,
            'binding' => $prefix . $serviceName
        );
        parent::__construct( 'port', $portAttributes );
        $address = new SimpleElement( 'soap:address', array (
            'location' => $endpointURI
        ), XMLNS_SOAP );
        $this->addChildDoc( $address );
    }
}

/***********************END OF WSDL-GENERATING CLASSES***********************/

/***********************START OF FILEMAKER REQUEST CLASSES***********************/

/**
 * This class will provide a direct connection to the Web Services Manager
 * database.
 */
class WebServiceManagerDB extends FileMaker {

    //Database connection constants
    const db = WEB_SVCS_MGR_DBNAME;

    //	const host = 'jesse.360works.com';
    const host = HOST;

    const user = 'user';

    const pass = PASSWORD;

    //Database layout and table constants
    const methodLayout = 'PHP Method Detail';

    const serviceLayout = 'PHP Service Detail';

    const settingsLayout = 'PHP User Settings';

    const fileLayout = 'PHP File Detail';

    const testLayout = 'Test';

    const fileTable = 'File';

    const methodTable = 'Available Methods';

    const methodPortal = 'Available Methods';

    const filePortal = 'Files from Available Methods';

    //Service mode constants
    const SINGLE_SERVICE = 2;

    const MULTI_SERVICE = 4;

    //Integer value of expiration date
    private $expiration;

    //Determines whether to display the WSDL for a single service or for all defined services
    private $serviceMode;

    private $namespace;
    const NAMESPACE_OVERRIDE = "Namespace override";
    const ADDITIONAL_NAMESPACES = 'Additional Namespaces';
    const SERVER_URL = 'Server URL';

    /**
     * @var $instance WebServiceManagerDB
     */
    private static $instance;

    /**
     * Constructor
     *
     * Establishes a connection to the Web Services Manager database and
     * initializes the settings properties
     */
    function __construct($service = NULL) {

        if (isset( $service )) {
            $this->serviceMode = self::SINGLE_SERVICE;
        } else {
            $this->serviceMode = self::MULTI_SERVICE;
        }

        $user = self::user;
        $pass = self::pass;
        if (empty( $user )) {
            parent::__construct( self::db, self::host );
        } elseif (empty( $pass )) {
            parent::__construct( self::db, self::host, self::user );
        } else {
            parent::__construct( self::db, self::host, self::user, self::pass );
        }

        $this->namespace = NS_URL;
    }

    /**
     * @return WebServiceManagerDB
     */
    public static function getInstance($service = NULL) {

        if (self::$instance == NULL) {
            self::$instance = new WebServiceManagerDB( $service );
        }
        return self::$instance;
    }

    public function __clone() {

        throw new BadMethodCallException( 'Cloning not allowed' );
    }

    public function getNamespace() {

        $namespaceOverride = NULL;
        $findNS = $this->newFindAnyCommand( self::settingsLayout );
        $nsResult = $findNS->execute();
        self::checkError( $nsResult, 'accessing Web Services Manager settings layout' );
        $nsRecord = $nsResult->getFirstRecord();
        $namespaceOverride = $nsRecord->getField(self::NAMESPACE_OVERRIDE);
        return empty( $namespaceOverride ) ? NS_URL : $namespaceOverride;
    }

    public function getServerName() {

        $record = $this->getSettingsRecord();
        return $record->getField(self::SERVER_URL);
    }

    public function getAdditionalNamespaces() {

        $record = $this->getSettingsRecord();
        return $record->getField(self::ADDITIONAL_NAMESPACES);
    }

    private function getSettingsRecord()
    {
        $findServerName = $this->newFindAnyCommand(self::settingsLayout);
        $serverNameResult = $findServerName->execute();
        self::checkError($serverNameResult, 'accessing Web Services Manager settings layout');
        $record = $serverNameResult->getFirstRecord();
        return $record;
    }

    public function getSettings() {
        $record = $this->getSettingsRecord();
        $fields = $record->getFields();
        $settings = array();
        foreach($fields as $field) {
            $value = $record->getField($field);
            if ($field == self::NAMESPACE_OVERRIDE && empty($value)) {
                $settings[$field] = NS_URL;
            } else {
                $settings[$field] = $value;
            }
        }
        return $settings;
    }

    public static function getErrors($code) {

        $__FM_ERRORS = array (
            -1 => 'Unknown error',
            0 => 'No error',
            1 => 'User canceled action',
            2 => 'Memory error',
            3 => 'Command is unavailable (for example, wrong operating system, wrong mode, etc.)',
            4 => 'Command is unknown',
            5 => 'Command is invalid (for example, a Set Field script step does not have a calculation specified)',
            6 => 'File is read-only',
            7 => 'Running out of memory',
            8 => 'Empty result',
            9 => 'Insufficient privileges',
            10 => 'Requested data is missing',
            11 => 'Name is not valid',
            12 => 'Name already exists',
            13 => 'File or object is in use',
            14 => 'Out of range',
            15 => 'Can\'t divide by zero',
            16 => 'Operation failed, request retry (for example, a user query) ',
            17 => 'Attempt to convert foreign character set to UTF-16 failed',
            18 => 'Client must provide account information to proceed',
            19 => 'String contains characters other than A-Z, a-z, 0-9 (ASCII)',
            100 => 'File is missing',
            101 => 'Record is missing',
            102 => 'Field is missing',
            103 => 'Relationship is missing',
            104 => 'Script is missing',
            105 => 'Layout is missing',
            106 => 'Table is missing',
            107 => 'Index is missing',
            108 => 'Value list is missing',
            109 => 'Privilege set is missing',
            110 => 'Related tables are missing',
            111 => 'Field repetition is invalid',
            112 => 'Window is missing',
            113 => 'Function is missing',
            114 => 'File reference is missing',
            130 => 'Files are damaged or missing and must be reinstalled',
            131 => 'Language pack files are missing (such as template files)',
            200 => 'Record access is denied',
            201 => 'Field cannot be modified',
            202 => 'Field access is denied',
            203 => 'No records in file to print, or password doesn\'t allow print access',
            204 => 'No access to field(s) in sort order',
            205 => 'User does not have access privileges to create new records; import will overwrite existing data',
            206 => 'User does not have password change privileges, or file is not modifiable',
            207 => 'User does not have sufficient privileges to change database schema, or file is not modifiable',
            208 => 'Password does not contain enough characters',
            209 => 'New password must be different from existing one',
            210 => 'User account is inactive',
            211 => 'Password has expired ',
            212 => 'Invalid user account and/or password. Please try again',
            213 => 'User account and/or password does not exist',
            214 => 'Too many login attempts',
            215 => 'Administrator privileges cannot be duplicated',
            216 => 'Guest account cannot be duplicated',
            217 => 'User does not have sufficient privileges to modify administrator account',
            300 => 'File is locked or in use',
            301 => 'Record is in use by another user',
            302 => 'Table is in use by another user',
            303 => 'Database schema is in use by another user',
            304 => 'Layout is in use by another user',
            306 => 'Record modification ID does not match',
            400 => 'Find criteria are empty',
            401 => 'No records match the request',
            402 => 'Selected field is not a match field for a lookup',
            403 => 'Exceeding maximum record limit for trial version of FileMaker Pro',
            404 => 'Sort order is invalid',
            405 => 'Number of records specified exceeds number of records that can be omitted',
            406 => 'Replace/Reserialize criteria are invalid',
            407 => 'One or both match fields are missing (invalid relationship)',
            408 => 'Specified field has inappropriate data type for this operation',
            409 => 'Import order is invalid ',
            410 => 'Export order is invalid',
            412 => 'Wrong version of FileMaker Pro used to recover file',
            413 => 'Specified field has inappropriate field type',
            414 => 'Layout cannot display the result',
            415 => 'One or more required related records are not available',
            500 => 'Date value does not meet validation entry options',
            501 => 'Time value does not meet validation entry options',
            502 => 'Number value does not meet validation entry options',
            503 => 'Value in field is not within the range specified in validation entry options',
            504 => 'Value in field is not unique as required in validation entry options ',
            505 => 'Value in field is not an existing value in the database file as required in validation entry options',
            506 => 'Value in field is not listed on the value list specified in validation entry option',
            507 => 'Value in field failed calculation test of validation entry option',
            508 => 'Invalid value entered in Find mode',
            509 => 'Field requires a valid value ',
            510 => 'Related value is empty or unavailable ',
            511 => 'Value in field exceeds maximum number of allowed characters',
            600 => 'Print error has occurred',
            601 => 'Combined header and footer exceed one page ',
            602 => 'Body doesn\'t fit on a page for current column setup',
            603 => 'Print connection lost',
            700 => 'File is of the wrong file type for import',
            706 => 'EPSF file has no preview image ',
            707 => 'Graphic translator cannot be found ',
            708 => 'Can\'t import the file or need color monitor support to import file',
            709 => 'QuickTime movie import failed ',
            710 => 'Unable to update QuickTime file reference because the database file is read-only',
            711 => 'Import translator cannot be found ',
            714 => 'Password privileges do not allow the operation',
            715 => 'Specified Excel worksheet or named range is missing',
            716 => 'A SQL query using DELETE, INSERT, or UPDATE is not allowed for ODBC import',
            717 => 'There is not enough XML/XSL information to proceed with the import or export',
            718 => 'Error in parsing XML file (from Xerces)',
            719 => 'Error in transforming XML using XSL (from Xalan)',
            720 => 'Error when exporting; intended format does not support repeating fields',
            721 => 'Unknown error occurred in the parser or the transformer',
            722 => 'Cannot import data into a file that has no fields',
            723 => 'You do not have permission to add records to or modify records in the target table',
            724 => 'You do not have permission to add records to the target table',
            725 => 'You do not have permission to modify records in the target table',
            726 => 'There are more records in the import file than in the target table. Not all records were imported',
            727 => 'There are more records in the target table than in the import file. Not all records were updated',
            729 => 'Errors occurred during import. Records could not be imported',
            730 => 'Unsupported Excel version. (Convert file to Excel 7.0 (Excel 95), Excel 97, 2000, or XP format and try again)',
            731 => 'The file you are importing from contains no data',
            732 => 'This file cannot be inserted because it contains other files',
            733 => 'A table cannot be imported into itself',
            734 => 'This file type cannot be displayed as a picture',
            735 => 'This file type cannot be displayed as a picture. It will be inserted and displayed as a file',
            800 => 'Unable to create file on disk',
            801 => 'Unable to create temporary file on System disk',
            802 => 'Unable to open file',
            803 => 'File is single user or host cannot be found',
            804 => 'File cannot be opened as read-only in its current state',
            805 => 'File is damaged; use Recover command',
            806 => 'File cannot be opened with this version of FileMaker Pro',
            807 => 'File is not a FileMaker Pro file or is severely damaged',
            808 => 'Cannot open file because access privileges are damaged',
            809 => 'Disk/volume is full',
            810 => 'Disk/volume is locked',
            811 => 'Temporary file cannot be opened as FileMaker Pro file',
            813 => 'Record Synchronization error on network',
            814 => 'File(s) cannot be opened because maximum number is open',
            815 => 'Couldn\'t open lookup file ',
            816 => 'Unable to convert file',
            817 => 'Unable to open file because it does not belong to this solution',
            819 => 'Cannot save a local copy of a remote file',
            820 => 'File is in the process of being closed',
            821 => 'Host forced a disconnect',
            822 => 'FMI files not found; reinstall missing files',
            823 => 'Cannot set file to single-user, guests are connected',
            824 => 'File is damaged or not a FileMaker file',
            900 => 'General spelling engine error',
            901 => 'Main spelling dictionary not installed',
            902 => 'Could not launch the Help system ',
            903 => 'Command cannot be used in a shared file ',
            904 => 'Command can only be used in a file hosted under FileMaker Server',
            905 => 'No active field selected; command can only be used if there is an active field',
            920 => 'Can\'t initialize the spelling engine',
            921 => 'User dictionary cannot be loaded for editing',
            922 => 'User dictionary cannot be found',
            923 => 'User dictionary is read-only',
            951 => 'An unexpected error occurred',
            954 => 'Unsupported XML grammar',
            955 => 'No database name',
            956 => 'Maximum number of database sessions exceeded',
            957 => 'Conflicting commands',
            958 => 'Parameter missing in query',
            1200 => 'Generic calculation error',
            1201 => 'Too few parameters in the function',
            1202 => 'Too many parameters in the function',
            1203 => 'Unexpected end of calculation',
            1204 => 'Number, text constant, field name or "(" expected',
            1205 => 'Comment is not terminated with "*/"',
            1206 => 'Text constant must end with a quotation mark',
            1207 => 'Unbalanced parenthesis',
            1208 => 'Operator missing, function not found or "(" not expected',
            1209 => 'Name (such as field name or layout name) is missing',
            1210 => 'Plug-in function has already been registered',
            1211 => 'List usage is not allowed in this function',
            1212 => 'An operator (for example, +, -, *) is expected here',
            1213 => 'This variable has already been defined in the Let function',
            1214 => 'AVERAGE, COUNT, EXTEND, GETREPETITION, MAX, MIN, NPV, STDEV, SUM and GETSUMMARY: expression found where a field alone is needed',
            1215 => 'This parameter is an invalid Get function parameter',
            1216 => 'Only Summary fields allowed as first argument in GETSUMMARY',
            1217 => 'Break field is invalid ',
            1218 => 'Cannot evaluate the number',
            1219 => 'A field cannot be used in its own formula',
            1220 => 'Field type must be normal or calculated ',
            1221 => 'Data type must be number, date, time, or timestamp ',
            1222 => 'Calculation cannot be stored',
            1223 => 'The function referred to does not exist',
            1400 => 'ODBC client driver initialization failed; make sure the ODBC client drivers are properly installed. Note: The plug-in component for sharing data via ODBC is installed automatically with FileMaker Server; the ODBC client drivers are installed using the FileMaker Server Web Publishing CD. For information, see Installing FileMaker ODBC and JDBC Client Drivers.',
            1401 => 'Failed to allocate environment (ODBC)',
            1402 => 'Failed to free environment (ODBC)',
            1403 => 'Failed to disconnect (ODBC)',
            1404 => 'Failed to allocate connection (ODBC)',
            1405 => 'Failed to free connection (ODBC)',
            1406 => 'Failed check for SQL API (ODBC)',
            1407 => 'Failed to allocate statement (ODBC)',
            1408 => 'Extended error (ODBC)'
        );

        return $__FM_ERRORS [$code];
    }

    public static function checkError($fmResult, $actionMsg) {

        $message = NULL;
        $errorString = NULL;
        if ($fmResult instanceof FileMaker_Error) {
            $message = $fmResult->getMessage();
            $errorString = $fmResult->getErrorString();
            $myError = empty( $message ) ? $errorString : $message;

            $code = $fmResult->getCode();
            if ($code == 211) {
                $myError = "\nThis error indicates that you need to open the 'Web Services Manager' database in FileMaker and change the password. Be sure to change the first line in the 'websvcmgr.php' file to reflect the new password that you select.\n" . $myError;
            } else if ($code == 22 && strpos( $myError, '404' ) !== FALSE) { //FIX! Nasty hack for conditional error reporting --jsb
                $myError = "\nCheck with the 360Works support staff about adding a port number to the HOST constant in the websvcmgr.php file.\n" . $myError;
            } else if ($code == 22 && $actionMsg == "getting a list of available services") { //FIX! Nasty hack for conditional error reporting --jsb
                $myError = "\nCheck the first line of the 'websvcmgr.php' file and make sure that the password there matches the one that you set for the 'Web Services Manager' database.\n" . $myError;
            } else if ($code == 802) {
                $myError = "<b>This file is not running on the server, or it does not have the FMXML and FMPHP privileges enabled for any accounts.</b>";
            }
            throw new ErrorException( "An error occurred while $actionMsg" . ".\n" . $myError, $code );
            //throw new ErrorException ( "An error occurred while $actionMsg" . ": " . $message . ' / ' . $errorString, $fmResult->getCode () );
        }
    }

    public static function checkLibXmlError($error, $actionMsg) {
        if($error instanceof LibXMLError) {;
            Logger::getLogger()->genericLog( $actionMsg );
            die( $actionMsg );
        }
    }

    function serviceFileMethodInfo() {

        if ($this->serviceMode == self::SINGLE_SERVICE) {
            $servicesFindCmd = $this->newFindCommand( self::serviceLayout );
            $servicesFindCmd->addFindCriterion( 'serviceName', $this->getProperty( 'serviceName' ) );
            $servicesFindCmd->addFindCriterion( 'isEnabled', '1' );
        } else {
            //$servicesFindCmd = $this->newFindAllCommand ( self::serviceLayout );
            $servicesFindCmd = $this->newFindCommand( self::serviceLayout );
            $servicesFindCmd->addFindCriterion( 'isEnabled', '1' );
        }
        $servicesFindResult = $servicesFindCmd->execute();
        self::checkError( $servicesFindResult, "getting a list of available services" );
        $servicesAllRecords = $servicesFindResult->getRecords();
        $resultArray = array ();
        $mergedArray = array ();
        foreach ( $servicesAllRecords as $serviceRecord ) {
            $this->expiration = $serviceRecord->getField( 'Registration::expiration' );
            $serviceName = $serviceRecord->getField( 'serviceName' ); //TODO Add error reporting --svr
            $serviceDocs = $serviceRecord->getField( 'serviceDocs' ); //TODO Add error reporting --svr
            $methodPortalResult = $serviceRecord->getRelatedSet( self::methodPortal );
            if ($methodPortalResult instanceof FileMaker_Error && $methodPortalResult->getMessage() != 'Related set "Available Methods" not present.') {
                self::checkError( $methodPortalResult, 'getting the operations associated with the service called ' . $serviceName );
            } else if (!($methodPortalResult instanceof FileMaker_Error)) {
                $resultArray ['services'] [$serviceName] = $methodPortalResult;
                $resultArray ['services'] [$serviceName] ['serviceDocs'] = $serviceDocs;
                $fileMethodMap = array_map( array (
                    $this,
                    'filesMethodsJoin'
                ), $methodPortalResult );
                $reducedArray = array_reduce( $fileMethodMap, array (
                    $this,
                    'reduceCallback'
                ) );
                $mergedArray = array_merge_recursive( $mergedArray, $reducedArray );
            }
        }
        $resultArray ['files'] = $mergedArray;
        return $resultArray;
    }

    private function reduceCallback($a1, $a2) {

        $returnArray = null;
        if (!isset( $a1 )) {
            $returnArray = $a2;
        } else {
            $returnArray = array_merge_recursive( $a1, $a2 );
        }
        return $returnArray;
    }

    private function filesMethodsJoin(FileMaker_Record $methodRecord) {

        $resultArray = FALSE;
        $fileName = $methodRecord->getField( self::filePortal . "::fileName" ); //TODO Add error reporting --svr
        $resultArray [$fileName] [] = $methodRecord;
        return $resultArray;
    }

    function getParameterRecords($methodName) { //TODO I am not sure if I should add error reporting here or not --svr


        $returnValue = FALSE;
        $parameterParentFind = $this->newFindCommand( self::methodLayout );
        $parameterParentFind->addFindCriterion( 'methodName', FILEMAKER_FIND_FIELDMATCH . $methodName );
        $parameterParentResult = $parameterParentFind->execute();

        if (!$this->isError( $parameterParentResult )) {
            $parameterParentRecord = $parameterParentResult->getFirstRecord();
            $parameterResult = $parameterParentRecord->getRelatedSet( 'Parameter' );

            if (!$this->isError( $parameterResult ) && !empty( $parameterResult )) {
                $returnValue = $parameterResult;
            }
        } elseif ($parameterResult instanceof FileMaker_Error) {
            Logger::getLogger()->genericLog( "No parameters exist for $methodName operation" );
        }
        return $returnValue;
    }

    private static function curlXMLGatewayURL($url) { //TODO Not sure whether to halt PHP script execution here or not --svr


        header( 'Content-type: text/xml', TRUE, 200 );
        $ch = curl_init( $url );
        curl_setopt( $ch, CURLOPT_RETURNTRANSFER, FALSE );
        curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, FALSE );

        if (!curl_exec( $ch )) {
            Logger::getLogger()->genericLog( curl_error( $ch ) );
        }
        return curl_getinfo( $ch, CURLINFO_HTTP_CODE );
    }

    public static function accessXMLGateway($user, $pass, $restOfQuery, $grammar = '') {

        $queryString = "";
        foreach ( $restOfQuery as $name => $value ) {
            $encValue = urlencode( $value );
            $queryString .= "$name" . (empty( $value ) ? '' : "=$encValue") . "&";
        }
        $queryString = trim( $queryString, '&' );
        $userPass = '';
        if (!empty( $user )) {
            $userPass .= $user;
        }
        if (!empty( $user ) && (!empty( $pass ) || $pass === "0")) {
            $userPass .= ':' . $pass . "@";
        } else if (!empty( $user ) && (empty( $pass ) && $pass !== "0")) {
            $userPass .= "@";
        }
        if ($grammar == '') {
            $grammar = 'fmresultset.xml';
        }
        $URL = "http://" . $userPass . HOST . "/fmi/xml/" . $grammar . "?" . $queryString;
        $responseCode = self::curlXMLGatewayURL( $URL );
        Logger::getLogger()->genericLog("Using cURL to access $URL");
        if ($responseCode == '401') {
            header( 'Content-type: text/xml', TRUE, 401 );
            Logger::getLogger()->genericLog("Not authorized to access $URL");
        }
    }

    // Automatic Getters and Setters
    function __call($method, $arguments) {

        $returnValue = NULL;
        $prefix = strtolower( substr( $method, 0, 3 ) );
        $propertyRest = substr( $method, 4 );
        $propertyFirst = strtolower( substr( $method, 3, 1 ) );
        $property = $propertyFirst . $propertyRest;
        if ($prefix == "get" && isset( $this->{$property} )) {
            $returnValue = $this->$property;
        }
        if ($prefix == "set") {
            $this->$property = $arguments [0];
        }
        return $returnValue;
    }
}

class Logger {

    const genericLogFile = 'websvcmgr.log';

    const reqRespLogFile = 'wsmRequest.log';

    /**
     * @var Logger
     */
    private static $logger;

    /**
     * @var DOMDocument
     */
    private $reqRespMsg;

    private $filePath;

    private function __construct() {

    }

    public final function __clone() {

        throw new BadFunctionCallException( 'Cloning of Logger not allowed' );
    }

    public function genericLog($message) {
        file_put_contents( LOG_LOCATION, 'v' . VERSION . ' ' . date( "D M j G:i:s T Y" ) . "\t" . $message . PHP_EOL, LOCK_EX | FILE_APPEND );
    }

    private function soapTransactionFileHandle($message) {

        if (empty( $message ) && $_SERVER ['REQUEST_METHOD'] == "POST") {
            throw new SoapFaultException( "This is an empty request; you must send XML data via POST. If you can confirm POST data was in fact sent, then check your pe_application_log.txt file for scripting errors.", "Client" );
        } elseif (empty( $message )) {
            if ($_SERVER ['SERVER_PORT'] == 80) {
                $port = '';
            } else {
                $port = ":{$_SERVER['SERVER_PORT']}";
            }
            $wsdlUrl = "http://{$_SERVER['SERVER_NAME']}$port{$_SERVER['SCRIPT_NAME']}?wsdl";
            $supportForumUrl = "http://www.fmforums.com/forum/showforum.php?fid/221/keyword/360works/";
            $errorMsg = <<<ERROR
<img src="http://www.360works.com/images/logo.gif" alt="360Works Logo" style="float:left; padding-right:30px;" /><span style="font:larger, bold;">Welcome to the 360Works Web Services Manager.</span>
<a href="$wsdlUrl">Click here</a> to view a Web Service Description Language (wsdl) file describing enabled operations and services. 
For additional product support, please refer to the documentation located in the Getting Started section of the Web Services Manager.fp7 file, or check out the <a href="$supportForumUrl">360Works Product Forum</a>.
ERROR;
            throw new ErrorException( $errorMsg );
        }

        $this->filePath = REQUEST_LOG_LOCATION;

        $this->reqRespMsg = new DOMDocument( '1.0');
        $loadXml = $this->reqRespMsg->loadXML( $message );
        if (!$loadXml) {
            $errors = libxml_get_last_error();
            $errorMsg = WSDL::formatXMLContent( $errors->message );
            throw new SoapFaultException( 'Invalid SOAP request: ' . $errorMsg, 'Client' );
            die();
        }
        $this->reqRespMsg->formatOutput = TRUE;
    }

    public function requestLog($message) {

        global $soapSchema;

        try {
            $this->soapTransactionFileHandle( $message );
            $envelopeFromProperNamespace = $this->reqRespMsg->getElementsByTagNameNS( XMLNS_ENVELOPE, 'Envelope' );
            $envelope = $this->reqRespMsg->getElementsByTagName( 'Envelope' );
            if (!($envelopeFromProperNamespace->length) && $envelope->length) {
                $errors = libxml_get_last_error();
                $errorMsg = WSDL::formatXMLContent( $errors->message );
                throw new SoapFaultException( "Envelope element must have namespace " . XMLNS_ENVELOPE, 'VersionMismatch' );
                die();
            }
            if (!$this->reqRespMsg->schemaValidateSource( $soapSchema )) {
                $errors = libxml_get_last_error();
                $errorMsg = WSDL::formatXMLContent( $errors->message );
                throw new SoapFaultException( 'Invalid SOAP request: ' . $errorMsg, 'Client' );
                die();
            }
        } catch (Exception $e) {
            file_put_contents( $this->filePath, 'v' . VERSION . ' ' . 'SOAP request received ' . date( "D M j G:i:s T Y" ) . PHP_EOL . PHP_EOL . $message . PHP_EOL . PHP_EOL, LOCK_EX | FILE_APPEND );
            throw $e;
        }
        file_put_contents( $this->filePath, 'v' . VERSION . ' ' . 'SOAP request received ' . date( "D M j G:i:s T Y" ) . PHP_EOL . PHP_EOL . $this->reqRespMsg->saveXML() . PHP_EOL . PHP_EOL, LOCK_EX | FILE_APPEND );
    }

    public function responseLog($message) {

        $this->soapTransactionFileHandle( $message );
        file_put_contents( $this->filePath, 'v' . VERSION . ' ' . 'SOAP response sent ' . date( "D M j G:i:s T Y" ) . PHP_EOL . PHP_EOL . $this->reqRespMsg->saveXML() . PHP_EOL . PHP_EOL, LOCK_EX | FILE_APPEND );
    }

    /**
     * @return Logger
     */
    public static function getLogger() {

        if (!self::$logger instanceof self) {
            self::$logger = new self( );
        }
        return self::$logger;
    }
}

class FileMakerMethod {

    private $auth;

    private $username;

    private $password;

    private $method;

    private $script;

    private $param;

    private $db;

    private $fileAlias;

    private $limit;

    private $lay;

    private $ns;

    private $isUsingXmlSchema;

    private $fileLevelLogin = FALSE;

    const SCRIPT_URL = SCRIPT_URL;

    const AUTH_GUEST = 2;

    const AUTH_SOAP = 16;

    const AUTH_FM = 128;

    /**
     * Enter description here...
     *
     * @var WebServiceManagerDB
     */
    public $webServicesManager;

    /**
     * Enter description here...
     *
     * @var FileMaker
     */
    public $fm;

    //TODO Make WebServiceManagerDB a Singleton --svr
    function __construct() {

    }

    function AuthenticatedUser($arguments) {

        $_SESSION ['user'] = $arguments ['username'];
        $_SESSION ['pass'] = $arguments ['password'];
    }

    static function SoapFault($faultCode, $faultString) {

        throw new SoapFaultException( $faultString, $faultCode );
    }

    function convertDateTypes($methodName, &$parameterArray) {

        $wsm = WebServiceManagerDB::getInstance();
        $methodFind = $wsm->newCompoundFindCommand( WebServiceManagerDB::methodLayout );
        if (is_array( $parameterArray )) {
            $i = 1;
            foreach ( $parameterArray as $name => $value ) {
                $methodFindReq = $wsm->newFindRequest( WebServiceManagerDB::methodLayout );
                $methodFindReq->addFindCriterion( "Parameter::parameterName", $name );
                $methodFindReq->addFindCriterion( "methodName", $methodName );
                $methodFind->add( $i, $methodFindReq );
                $i++;
            }
            $methodFindResult = $methodFind->execute();
            try {
                WebServiceManagerDB::checkError( $methodFindResult, "getting type of $parameterArray from the $methodName operation" );
            } catch ( ErrorException $e ) {
                throw new SoapFaultException( $e->getMessage(), "Server" );
            }
            $resultArray = $methodFindResult->getRecords();
            foreach ( $resultArray as $result ) {
                $parameterSet = $result->getRelatedSet( 'Parameter' );
                $this->convertDateTypesPerParam( $parameterSet, $parameterArray);
            }
        }
    }

    function convertDateTypesPerParam($parameterSet, &$parameterArray) {

        if (is_array( $parameterSet ) && count( $parameterSet ) >= 1) {
            foreach ( $parameterSet as $parameterRecord ) {
                $parameterName = ucwords( $parameterRecord->getField( 'Parameter::parameterName' ) );
                $parameterType = $parameterRecord->getField( 'Parameter::parameterType' );
                if ($parameterType == 'date') {
                    $dateTime = new DateTime( $parameterArray [$parameterName] );
                    $parameterArray [$parameterName] = $dateTime->format( 'm/d/Y' );
                } elseif ($parameterType == 'time') {
                    $dateTime = new DateTime( $parameterArray [$parameterName] );
                    $parameterArray [$parameterName] = $dateTime->format( 'h:i:s A' );
                } elseif ($parameterType == 'timestamp') {
                    $dateTime = new DateTime( $parameterArray [$parameterName] );
                    $parameterArray [$parameterName] = $dateTime->format( 'm/d/Y h:i:s A' );
                }
            }
        }
    }

    function callScript($method, $scriptParameter, $rawSoapRequest) {

        $operation = NULL;
        $methodRecord = NULL;
        $operationCacheFile = strtolower( $method ) . '.cache';
        $this->method = $method;
        $expirationAsInt = NULL;
        if ($serializedCache = readOperationCache( $operationCacheFile )) {
            $operation = unserialize( $serializedCache );
            $expiration = $operation['expiration'];
            if(PHP_INT_SIZE === 4) {
                $expiration = str_replace("12/12/2999", "01/18/2038", $expiration);
            }
            $expirationAsInt = strtotime($expiration);
        }

        if (isset( $expirationAsInt ) && (time() < $expirationAsInt)) {
            $method = $operation['methodName'];
            $this->isUsingXmlSchema = isset( $operation ) ? $operation ['isUsingXmlSchema'] : 0;
            Logger::getLogger()->genericLog( "Executing $method operation from $operationCacheFile file data." );
            $this->ns = $operation ['ns'];
            $cachedParameters = isset( $operation ) ? $operation ['parameters'] : NULL;
            if(!$this->isUsingXmlSchema) {
                $this->convertDateTypesPerParam( $cachedParameters, $scriptParameter);
            }
            $this->method = $method;
        } else {
            $operation = null;
            $this->webServicesManager = WebServiceManagerDB::getInstance();
            $methodCompoundFind = $this->webServicesManager->newCompoundFindCommand(WebServiceManagerDB::methodLayout);
            $methodFindReq = $this->webServicesManager->newFindRequest( WebServiceManagerDB::methodLayout );
            $methodFindReq->addFindCriterion( 'methodName', FILEMAKER_FIND_FIELDMATCH . $method );
            $altMethodFindReq = $this->webServicesManager->newFindRequest( WebServiceManagerDB::methodLayout );
            $altMethodFindReq->addFindCriterion( 'xmlAltMsg', FILEMAKER_FIND_FIELDMATCH . $method );
            $methodDetailResult = $methodCompoundFind->execute();
            try {
                WebServiceManagerDB::checkError( $methodDetailResult, "invoking the $method operation" );
            } catch ( ErrorException $e ) {
                throw new SoapFaultException( $e->getMessage(), "Server" );
            }
            $methodRecord = $methodDetailResult->getFirstRecord();
            $this->isUsingXmlSchema = $methodRecord->getField( "isUsingXmlSchema" );
            $this->method = $methodRecord->getField("methodName");
            $this->ns = $this->webServicesManager->getNamespace();
            if (is_array( $scriptParameter ) && !empty( $scriptParameter ) && !$this->isUsingXmlSchema) {
                $this->convertDateTypes( $method, $scriptParameter );
            }
        }

        $methodAuthSelection = isset( $operation ) ? $operation ['methodAuthSelection'] : $methodRecord->getField( "methodAuthSelection" );
        if ($methodAuthSelection == 'Run script as guest') {
            $this->username = NULL;
            $this->password = NULL;
            $this->auth = self::AUTH_GUEST;
        } elseif ($methodAuthSelection == 'Run script with username/password from web service SOAP header') {
            $this->username = $_SESSION ['user'];
            $this->password = $_SESSION ['pass'];
            $this->auth = self::AUTH_SOAP;
        } elseif ($methodAuthSelection == 'Run script with this username/password:') {
            $this->username = isset ($operation) ? $operation['userName'] : $methodRecord->getField( "userName" );
            $this->password = isset ($operation) ? $operation['password'] : $methodRecord->getField( "password" );
            $this->auth = self::AUTH_FM;
        }
        $this->lay = isset( $operation ) ? $operation ['layoutName'] : $methodRecord->getField( "layoutName" );
        $this->db = isset( $operation ) ? $operation ['fileName'] : $methodRecord->getField( "File::fileName" );
        $this->fileAlias = isset ( $operation) ? $operation ['fileAlias'] : $methodRecord->getField("File::alias");
        $this->script = isset( $operation ) ? $operation ['scriptNameCalc'] : $methodRecord->getField( "scriptNameCalc" );
        if ($this->script == "WSM No Access") {
            self::SoapFault( "Client", "Unable to execute the method because your registration or demo period has expired. 
            Please register or extend your demo period by selecting Register from the top navigation panel of the Web Services Manager FileMaker file." );
        }

        $returnFirstRecord = isset( $operation ) ? $operation ['returnFirstRecord'] : $methodRecord->getField( 'returnFirstRecord' );
        $maxRecords = isset( $operation ) ? $operation ['maxRecords'] : $methodRecord->getField( 'maxRecords' );

        if ($returnFirstRecord) {
            $this->limit = 1;
        } elseif ($maxRecords) {
            $this->limit = $maxRecords;
        }

        if (!$this->isUsingXmlSchema) {
            $getParamsByName = isset( $operation ) ? $operation ['getParamsByName'] : $methodRecord->getField( 'getParamsByName' );
            if (count( $scriptParameter )) {
                if ($getParamsByName) {
                    foreach ( $scriptParameter as $name => $value ) {
                        $this->param .= "<$name>" . str_replace( "\n", "\r", $value ) . "</$name>";
                    }
                } else {
                    $parsedScriptParameter = "";
                    foreach ( $scriptParameter as $value ) {
                        $parsedScriptParameter .= $value . "\r";
                    }
                    $this->param = trim($parsedScriptParameter);
                }
            }
        } else {
            $this->param = $rawSoapRequest;
        }

        $this->executeScriptUsingXML();
    }

    function executeScriptUsingXML() {

        $postArray ['-db'] = $this->db;
        $postArray ['-lay'] = $this->lay;
        if (isset( $this->script ) && !empty( $this->script )) {
            $postArray ['-script'] = $this->script;
            if (isset( $this->isUsingXmlSchema ) && $this->isUsingXmlSchema) {
                $postArray ['-script.param'] = $this->param;
            } elseif (!empty( $this->param )) {
                $postArray ['-script.param'] = $this->param;
            }
        }
        $returnFirstRecord = '0';
        if (isset( $this->limit )) {
            $postArray ['-max'] = $this->limit;
            if ($this->limit == 1)
                $returnFirstRecord = '1';
        }
        $postArray ['-findall'] = '';
        //$postArray ['-find'] = '';

        $postData = http_build_query( $postArray );

        Logger::getLogger()->genericLog('FMP XML query string: ' . $postData);

        $reader = new XMLReader( );
        $writer = new XMLWriter( );
        $logWriter = new XMLWriter( LOG_LOCATION );

        $serverPort = SERVER_PORT;
        $scriptUrl = "http://" . WebServiceManagerDB::host . "/fmi/xml/fmresultset.xml";

        $opts = array (
            'http' => array (
                'method' => 'POST',
                'header' => 'Authorization: Basic ' . base64_encode( "{$this->username}:{$this->password}" ) . PHP_EOL .
                    'Content-Type:application/x-www-form-urlencoded',
                'content' => $postData
            )
        );

        $context = stream_context_create( $opts );
        libxml_set_streams_context( $context );

        if(defined("LIBXML_PARSEHUGE")) {
            Logger::getLogger()->genericLog("Enabling huge XML parsing for libxml version " . LIBXML_DOTTED_VERSION);
            $reader->open( $scriptUrl, "UTF-8", LIBXML_PARSEHUGE );
        } else {
            Logger::getLogger()->genericLog("Huge XML parsing unavailable for libxml version " . LIBXML_DOTTED_VERSION);
            $reader->open( $scriptUrl, "UTF-8" );
        }
        $libXMLError = libxml_get_last_error();
        WebServiceManagerDB::checkLibXmlError($libXMLError, "An error occurred while trying to open an XML resource stream");

        $responseCode = $http_response_header [0];
        Logger::getLogger()->genericLog("HTTP response code from post to $scriptUrl: $responseCode");
        if (stripos( $responseCode, '401' )) {
            switch ($this->auth) {
                case self::AUTH_FM :
                    throw new SoapFaultException( "Unable to perform the '{$this->method}' operation. Access to the '{$this->db}' database denied using the '{$this->username}' account configured in the Web Services Manager.fp7 file.", 'Server' );
                    break;

                case self::AUTH_GUEST :
                    throw new SoapFaultException( "Unable to perform the '{$this->method}' operation. Access to the '{$this->db}' database denied using the guest account.", 'Server' );
                    break;

                case self::AUTH_SOAP :
                    throw new SoapFaultException( "Unable to perform the '{$this->method}' operation. Access to the '{$this->db}' database denied using the '{$this->username}' account credentials provided in the SOAP request header.", 'Server' );
                    break;
            }

        }
        $inPortal = FALSE;
        $isUserDefinedError = FALSE;
        $responseLog = '';

        header( 'Content-type:text/xml;charset=utf-8', TRUE, 200 );
        $writer->openUri( "php://output" );

        $lock = FALSE;
        $logFilePointer = fopen( REQUEST_LOG_LOCATION, 'ab' );
        // exclusive lock
//        if ($lock = flock( $logFilePointer, LOCK_EX )) {
//            fwrite( $logFilePointer, 'SOAP response sent ' . date( "D M j G:i:s T Y" ) . PHP_EOL . PHP_EOL );
//
//        } else {
//            Logger::getLogger()->genericLog( 'Unable to lock ' + LOG_LOCATION + ' for writing.' );
//        }
//        $isContainer[$preFormatField] = false;
        while ( $reader->read() ) {
            $break = TRUE;
            $type = $reader->nodeType;
            switch ($type) {
                case XMLReader::ELEMENT :
                    $name = $reader->name;
                    switch ($name) {
                        case 'error' :
                            $code = ( int ) $reader->getAttribute( 'code' );
                            if ($code == '104') {
//                                if ($lock)
//                                    flock( $logFilePointer, LOCK_UN ); // release the lock
//                                fclose( $logFilePointer );
                                $this->SoapFault( 'Server', "Script $this->script is missing or you lack the privileges necessary to execute it." );
                            } elseif ($code == '401' && !$returnFirstRecord) {
                                Logger::getLogger()->genericLog('No records found');
                            } elseif ($code) {
//                                if ($lock)
//                                    flock( $logFilePointer, LOCK_UN ); // release the lock
//                                fclose( $logFilePointer );
                                $this->SoapFault( 'Server', WebServiceManagerDB::getErrors( $code ) );
                            }
                            break;
                        case 'datasource' :
                            $layout = WSDL::formatXMLTag( $reader->getAttribute( 'layout' ) );
                            if (strcasecmp( $layout, 'websvcmgrerror' ) === 0) {
                                $isUserDefinedError = TRUE;
                            }
                            break;
                        case 'resultset' :
                            if ($reader->getAttribute( 'count' ) == '0' && $this->limit == '1') {
                                $errorMsg = 'No record was found for this operation.';
//                                fclose( $logFilePointer );
//                                if ($lock)
//                                    flock( $logFilePointer, LOCK_UN ); // release the lock
                                $this->SoapFault( 'Server', $errorMsg );
                            } elseif ($isUserDefinedError) {
                                while ( $reader->read() ) {
                                    if ($reader->nodeType == XMLReader::TEXT) {
                                        $errorMsg = $reader->value;
                                        break;
                                    } else {
                                        $errorMsg = "The 'websvcmgrerror' layout must have at least one record to report a user-defined error.";
                                    }
                                }
//                                if ($lock)
//                                    flock( $logFilePointer, LOCK_UN ); // release the lock
//                                fclose( $logFilePointer );
                                $this->SoapFault( 'Client', $errorMsg );
                            } else {
                                $namespaceURI = $this->ns . '/' . WSDL::formatXMLTag( isset($this->fileAlias) && strlen($this->fileAlias) > 0 ? $this->fileAlias : $this->db);
                                $writer->startDocument( "1.0", "UTF-8" );
                                $writer->setIndent( 4 );
                                $writer->startElement( 'soap:Envelope' );
                                $writer->writeAttribute( 'xmlns:soap', XMLNS_ENVELOPE );
                                $writer->writeAttribute( 'xmlns:xsi', XMLNS_XSI );
                                $writer->startElement( 'soap:Body' );
                                $writer->startElement( $this->method . 'Response' );
                                $writer->writeAttribute( 'xmlns', $namespaceURI );

//                                if ($lock)
                                /*fwrite( $logFilePointer, '<?xml version="1.0" encoding="UTF-8"?>' . PHP_EOL . '<soap:Envelope xmlns:soap="' . XMLNS_ENVELOPE . '">' . PHP_EOL . '<soap:Body>' . PHP_EOL . "<{$this->method}Response xmlns=\"$namespaceURI\">" . PHP_EOL );*/
                                Logger::getLogger()->genericLog( "returnFirstRecord: $returnFirstRecord" );
                                if (!$returnFirstRecord) {
                                    Logger::getLogger()->genericLog( "Adding array" );
                                    $writer->startElement( "ArrayOf$layout" );
//                                    if ($lock)
//                                        fwrite( $logFilePointer, "<ArrayOf$layout>" . PHP_EOL );
                                } else {
                                    Logger::getLogger()->genericLog( "Skipping array" );
                                }
                            }
                            break;
                        case 'field-definition' :
                            $fieldResult = $reader->getAttribute( 'result' );
                            if ($fieldResult != 'unknown') {
                                $fieldType [$reader->getAttribute( 'name' )] = $reader->getAttribute( 'result' );
                            }
                            $fieldNillable[$reader->getAttribute ( 'name' )] = $reader->getAttribute ( 'not-empty' ) === 'no';
                            break;
                        case 'record' :
                            if (!$inPortal) {
                                $writer->startElement( $layout );
//                                if ($lock)
//                                    fwrite( $logFilePointer, "<$layout>" . PHP_EOL );
                            } else {
                                $writer->startElement( $table );
//                                if ($lock)
//                                    fwrite( $logFilePointer, "<$table>" . PHP_EOL );
                            }
                            break;
                        case 'relatedset' :
                            $inPortal = TRUE;
                            $table = WSDL::formatXMLTag( $reader->getAttribute( 'table' ) );
                            break;
                        case 'field' :
                            $preFormatField = $reader->getAttribute( 'name' );
                            if (empty( $preFormatField )) {
                                $preFormatField = 'NoAccess';
                            }
                            $fieldName = WSDL::formatXMLTag( $preFormatField );
                            $portalPrefix = WSDL::formatXMLTag( $table . "__" );
                            if ($inPortal && strpos( $fieldName, $portalPrefix ) === 0) {
                                $count = 1;
                                $fieldName = str_replace( $portalPrefix, "", $fieldName, $count );
                            }
                            $reader->read();
                            $name = $reader->name;
                            $type = $reader->nodeType;
                            $break = FALSE;
                            $user = empty( $this->username ) ? 'Guest' : $this->username;
                            if ($name == 'field' && $type == XMLReader::END_ELEMENT && $fieldName == 'NoAccess') {
                                $noAccessXMLContent = WSDL::formatXMLContent( "Unable to access field data. This field most likely comes from an external data source that lacks a user account with the same authentication credentials and access privileges as the '$user' account used to access '{$this->db}.fp7'." );
                                $writer->writeElement( $fieldName, $noAccessXMLContent );
//                                if ($lock)
//                                    fwrite( $logFilePointer, "<$fieldName>$noAccessXMLContent</$fieldName>" . PHP_EOL );
                            } elseif ($name == 'field' && $type == XMLReader::END_ELEMENT) {
                                $noAccessXMLContent = WSDL::formatXMLContent( "Unable to access field data. Check the privileges for the '$user' account used to access '{$this->db}.fp7'." );
                                $writer->writeElement( $fieldName, $noAccessXMLContent );
//                                if ($lock)
//                                    fwrite( $logFilePointer, "<$fieldName>$noAccessXMLContent</$fieldName>" . PHP_EOL );
                            } else if($fieldType[$preFormatField] == 'container') {
                                $writer->writeRaw("<$fieldName>");
//                                if($lock)
//                                    fwrite ($logFilePointer, "<$fieldName>");
                            }
                    }
                    if ($break) {
                        break;
                    }
                case XMLReader::CDATA :
                case XMLReader::TEXT :
//                case XMLReader::WHITESPACE :
                case XMLReader::SIGNIFICANT_WHITESPACE :
                    if ($name == 'data' && $reader->hasValue) {
                        /*$writer->writeRaw("<$fieldName>");
                        if ($lock)
                            fwrite( $fh, "<$fieldName>" );
                        $type = $fieldType [$preFormatField];*/
                        $fmType = $fieldType [$preFormatField];
                        $value = $reader->value;
                        switch ($fmType) {
                            case 'text' :
                                $isContainer[$preFormatField] = false;
                                $xmlContent = WSDL::formatXMLContent( $value );
                                break;
                            case 'number' :
                                $isContainer[$preFormatField] = false;
                                $xmlContent = $value;
                                break;
                            case 'date' :
                                $isContainer[$preFormatField] = false;
                                $xmlContent = date( 'Y-m-d', strtotime( $value ) );
                                break;
                            case 'time' :
                                $isContainer[$preFormatField] = false;
                                $xmlContent = date( 'H:i:sP', strtotime( $value ) );
                                break;
                            case 'timestamp' :
                                $isContainer[$preFormatField] = false;
                                $xmlContent = date( DATE_W3C, strtotime( $value ) );
                                break;
                            case 'container':
                                $isContainer[$preFormatField] = true;
                                $urlMatch = array();
                                $hasAMatch = preg_match( FMXML_PREFIX, $value, $urlMatch );
                                if ($hasAMatch !== 0 && $hasAMatch !== FALSE && count( $urlMatch ) > 0) {
                                    $urlFragment = $urlMatch [0];
                                    Logger::getLogger()->genericLog( "URL Fragment: $urlFragment" );
                                    $content = preg_replace( FMXML_PREFIX, '', $value );
                                    //                                $content = str_replace(FMXML_PREFIX . '?', '', $value);
                                    Logger::getLogger()->genericLog( "Query string for requested container data: $content" );

                                    $options ['http'] = array (
                                        'method' => 'POST',
                                        'header' => 'Authorization: Basic ' . base64_encode( "{$this->username}:{$this->password}" ) . PHP_EOL . 'Content-Length: ' . strlen( $content ),
                                        'content' => $content );
                                    $binContext = stream_context_create( $options );
                                    //                                $containerUrl = "http://" . HOST . $value;
                                    $containerUrl = "http://" . HOST . $urlFragment;
                                    $containerFilePointer = fopen( $containerUrl, 'r', null, $binContext );
                                    stream_filter_append( $containerFilePointer, 'convert.base64-encode' );
                                    $bytesRead = fpassthru( $containerFilePointer );
                                    if ($bytesRead === false) {
                                        Logger::getLogger()->genericLog( "Unable to stream binary data from $containerUrl ({$http_response_header[0]})" );
                                    }

//                                    if ($lock && is_resource($logFilePointer)) {
//                                        fwrite( $logFilePointer, WSDL::formatXMLContent( "base64Binary(read $bytesRead bytes from " . $containerUrl . ")" ) . PHP_EOL );
//                                    }
                                } else {
                                    Logger::getLogger()->genericLog("Unable to find a match for the pattern " + FMXML_PREFIX + " in $value. Unable to stream container data.");
                                }
                                break;
                            default :
                                $isContainer[$preFormatField] = false;
                                $xmlContent = WSDL::formatXMLContent( $value );
                                break;
                        }
                        /*if ($fmType != 'container') {
//                            $writer->text( $xmlContent );
                            if ($lock)
                                fwrite( $logFilePointer, $xmlContent );
                        }*/
                    }/* else if($name == 'data') {
                        $nillable = is_array($fieldNillable) ? $fieldNillable[$preFormatField] : true;
                        $fieldNameElement = "<$fieldName xsi:nil=\"" . ($nillable ? "true" : "false") . "\">";
                        $writer->writeRaw($fieldNameElement);
                        if($lock) {
                            fwrite($fh, $fieldNameElement);
                        }
                    }*/
                    break;
                case XMLReader::END_ELEMENT :
                    $name = $reader->name;
                    if ($name == 'fmresultset') {
                        if (!$returnFirstRecord) {
                            $writer->endElement();
//                            if ($lock)
//                                fwrite( $logFilePointer, "</ArrayOf$layout>" . PHP_EOL );
                        }
                        $writer->endElement();
                        $writer->endElement();
                        $writer->endElement();

//                        if ($lock)
//                            fwrite( $logFilePointer, "</{$this->method}Response>" . PHP_EOL . "</soap:Body>" . PHP_EOL . "</soap:Envelope>" . PHP_EOL );
                    }
                    if ($name == 'record') {
                        if (!$inPortal) {
                            $writer->endElement();
//                            if ($lock)
//                                fwrite( $logFilePointer, "</$layout>" . PHP_EOL );
                        } else {
                            $writer->endElement();
//                            if ($lock)
//                                fwrite( $logFilePointer, "</$table>" . PHP_EOL );
                        }
                    }
                    if ($name == 'field') {
                        if (!$inPortal) {
                            $preFormatField = $reader->getAttribute('name');
                            $fieldName = WSDL::formatXMLTag($preFormatField);
                        }
                        if ($isContainer[$preFormatField] === true) {
                            $fieldNameElement = "</$fieldName>";
                            $writer->writeRaw($fieldNameElement);
//                            if ($lock)
//                                fwrite($logFilePointer, $fieldNameElement . PHP_EOL);
                        } else {
                            $nillable = is_array($fieldNillable) ? $fieldNillable[$preFormatField] : true;
                            $fieldNameElement = ($xmlContent == null || $xmlContent == "") ? "<$fieldName xsi:nil=\"" . ($nillable ? "true" : "false") . "\">$xmlContent</$fieldName>" : "<$fieldName>$xmlContent</$fieldName>";
                            $writer->writeRaw($fieldNameElement);
//                            if ($lock)
//                                fwrite($logFilePointer, $fieldNameElement . PHP_EOL);
                        }
                        $xmlContent = '';
                        $value = '';
                    }
                    if ($name == 'relatedset') {
                        $inPortal = FALSE;
                        $table = WSDL::formatXMLTag( $reader->getAttribute( 'table' ) );
                    }
                    break;
            }
            $writer->flush( false );
            if (ob_get_length() > 0) {
                ob_flush();
                flush();
            }
        }
        $writer->flush();
        if (ob_get_length() > 0) {
            ob_end_flush();
            flush();
        }
//        if ($lock)
//            flock( $logFilePointer, LOCK_UN ); // release the lock
//        fclose( $logFilePointer );
        $reader->close();
    }
}

/***********************END OF FILEMAKER REQUEST CLASSES***********************/

/***********************START OF SOAP REQUEST CLASSES***********************/

class Xml2Assoc {

    /**
     * Optimization Enabled / Disabled
     *
     * @var bool
     */
    protected $bOptimize = false;

    /**
     * Method for loading XML Data from String
     *
     * @param string $sXml
     * @param bool $bOptimize
     */

    public function parseString($sXml, $bOptimize = false) {

        $oXml = new XMLReader( );
        $this->bOptimize = ( bool ) $bOptimize;
        try {
            // Set String Containing XML data 
            $oXml->XML( $sXml );

        } catch ( Exception $e ) {
            throw $e;
        }
        // Parse Xml and return result 
        return $this->parseXml( $oXml );
    }

    /**
     * XML Parser
     *
     * @param XMLReader $oXml
     * @return array
     */
    protected function parseXml(XMLReader $oXml) {

        $aAssocXML = null;
        $iDc = -1;

        while ( $oXml->read() ) {
            switch ($oXml->nodeType) {

                case XMLReader::END_ELEMENT :

                    if ($this->bOptimize) {
                        $this->optXml( $aAssocXML );
                    }
                    return $aAssocXML;

                case XMLReader::ELEMENT :

                    if (!isset( $aAssocXML [$oXml->localName] )) {
                        if ($oXml->isEmptyElement) {
                            $aAssocXML [$oXml->localName] = '';
                        } else {
                            $aAssocXML [$oXml->localName] = $this->parseXML( $oXml );
                        }
                    } elseif (is_array( $aAssocXML [$oXml->localName] )) {
                        if (!isset( $aAssocXML [$oXml->localName] [0] )) {
                            $aTemp = $aAssocXML [$oXml->localName];
                            foreach ( $aTemp as $sKey => $sValue )
                                unset( $aAssocXML [$oXml->localName] [$sKey] );
                            $aAssocXML [$oXml->localName] [] = $aTemp;
                        }
                        if ($oXml->isEmptyElement) {
                            $aAssocXML [$oXml->localName] [] = '';
                        } else {
                            $aAssocXML [$oXml->localName] [] = $this->parseXML( $oXml );
                        }
                    } else {
                        $mOldVar = $aAssocXML [$oXml->localName];
                        $aAssocXML [$oXml->localName] = array (
                            $mOldVar
                        );
                        if ($oXml->isEmptyElement) {
                            $aAssocXML [$oXml->localName] [] = '';
                        } else {
                            $aAssocXML [$oXml->localName] [] = $this->parseXML( $oXml );
                        }
                    }
                    break;
                case XMLReader::TEXT :
                case XMLReader::CDATA :
                    $aAssocXML [++$iDc] = $oXml->value;
            }
        }
        return $aAssocXML;
    }

    /**
     * Method to optimize assoc tree.
     * ( Deleting 0 index when element
     *  have one attribute / value )
     *
     * @param array $mData
     */
    public function optXml(&$mData) {

        if (is_array( $mData )) {
            if (isset( $mData [0] ) && count( $mData ) == 1) {
                $mData = $mData [0];
                if (is_array( $mData )) {
                    foreach ( $mData as &$aSub ) {
                        $this->optXml( $aSub );
                    }
                }
            } else {
                foreach ( $mData as &$aSub ) {
                    $this->optXml( $aSub );
                }
            }
        }
    }
}

class SoapFaultException extends ErrorException {

    private $faultcode;

    /**
     * @return string
     */
    public function getFaultcode() {

        return $this->faultcode;
    }

    /**
     * @param string $faultcode
     */
    public function setFaultcode($faultcode) {

        $this->faultcode = $faultcode;
    }

    function __construct($faultstring, $faultcode) {

        parent::__construct( $faultstring );
        $this->faultcode = $faultcode;
    }

    function __toString() {

        /*header ( "Content-Type: text/xml", TRUE, 500 );
		$soapFaultXML = <<<SOAPFAULT
<?xml version="1.0" encoding="UTF-8"?>
<Envelope xmlns="http://schemas.xmlsoap.org/soap/envelope" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<Body>
<SOAP-ENV:Fault xmlns="">
<faultcode>SOAP-ENV:{$this->faultcode}</faultcode>
<faultstring>{$this->message}</faultstring>
</SOAP-ENV:Fault>
</Body>
</Envelope>
SOAPFAULT;
		return $this->loadDOM ( $soapFaultXML );*/
        return generate_soap_fault_payload( $this->faultcode, $this->message );
    }

    function loadDOM($xmlString) {

        $dom = new DOMDocument( '1.0', 'UTF-8' );
        $dom->loadXML( $xmlString );
        $dom->formatOutput = TRUE;
        return $dom->saveXML();
    }
}

/***********************END OF SOAP REQUEST CLASSES***********************/

/***********************START OF MAIN***********************/
//ob_start ();


//register_shutdown_function ( 'fatalErrorHandler' );


try {
    $get = array_change_key_case( $_GET );
    //Generate WSDL file
    if (array_key_exists( 'wsdl', $get )) {
        //		$wsm = new WebServiceManagerDB ( );
        $wsm = WebServiceManagerDB::getInstance();
        if (array_key_exists( 'service', $get )) {
            $serviceName = $get ['service'];
            $wsm->setProperty( 'serviceName', $serviceName );
            $wsm->setServiceMode( WebServiceManagerDB::SINGLE_SERVICE );
        } else {
            $wsm->setServiceMode( WebServiceManagerDB::MULTI_SERVICE );
        }

        $wsm->setProperty( 'authType', 'AuthenticatedUser' );


        $servicesFiles = $wsm->serviceFileMethodInfo();

        $fileToMethodRecords = $servicesFiles ['files'];
        $serviceToMethodRecords = $servicesFiles ['services'];

//        $serverName = $wsm->getServerName();
//        $namespace = $wsm->getNamespace();
//        $additionalNamespaces = $wsm->getAdditionalNamespaces();

        $settings = $wsm->getSettings();
        $serverName = $settings[WebServiceManagerDB::SERVER_URL];
        $namespace = $settings[WebServiceManagerDB::NAMESPACE_OVERRIDE];
        $additionalNamespaces = $settings[WebServiceManagerDB::ADDITIONAL_NAMESPACES];

        $wsdl = new WSDL($namespace);

        $additionalNamespaceArray = explode("\n", $additionalNamespaces);
        foreach($additionalNamespaceArray as $additionalNamespace) {
            $nameValue = explode("=", trim($additionalNamespace));
            if(count($nameValue) == 2) {
                $wsdl->getRoot()->setAttribute($nameValue[0], trim(html_entity_decode($nameValue[1], ENT_COMPAT, "UTF-8"), '"'));
            }
        }

        $authMsg = NULL;
        $authSchema = NULL;
        $schema = NULL;

        $msgArray = NULL;
        $schemaArray = NULL;

        $types = new SimpleElement( 'types' );

        $i = 1;

        $filePrefix = WebServiceManagerDB::filePortal . "::";
        $methodPrefix = WebServiceManagerDB::methodPortal . "::";

        foreach ( $fileToMethodRecords as $fileName => $methodRecords ) {
            $namespacePrefix = "db$i";
            $layoutWrapperArray = NULL; //Stores names of complex types defined for request operations
            $portalTypeArray = NULL; //Stores names of portal tables
            $layoutTypeArray = NULL; //Stores names of complex types defined for request operations

            $isNamespaceSet = false;
            foreach ( $methodRecords as $record ) {
                if(!$isNamespaceSet) {
                    $fileAlias = $record->getField("{$filePrefix}alias");
                    if(isset($fileAlias) and strlen($fileAlias) > 0) {
                        $ns ["xmlns:db$i"] = $namespace . '/' . WSDL::formatXMLTag( $fileAlias );
                        $schema = new MySchema( $namespace . '/' . WSDL::formatXMLTag( $fileAlias ), $namespacePrefix );
                    } else {
                        $ns ["xmlns:db$i"] = $namespace . '/' . WSDL::formatXMLTag( $fileName );
                        $schema = new MySchema( $namespace . '/' . WSDL::formatXMLTag( $fileName ), $namespacePrefix );
                    }
                    $isNamespaceSet = true;
                }

                $methodName = ucfirst( $record->getField( "{$methodPrefix}methodName" ) );

                $fileName = $record->getField( "{$filePrefix}fileName" );
                $username = $record->getField( "{$filePrefix}userName" );
                $password = $record->getField( "{$filePrefix}password" );
                $layout = $record->getField( "{$methodPrefix}layoutName" );
                $returnFirstRecord = $record->getField( "{$methodPrefix}returnFirstRecord" );
                $methodDocs = $record->getField( "{$methodPrefix}methodDocs" );
                $methodAuthSelection = $record->getField( "{$methodPrefix}methodAuthSelection" );
                $isUsingXmlSchema = $record->getField( "{$methodPrefix}isUsingXmlSchema" );
                $xmlSchema = $record->getField( "{$methodPrefix}xmlSchema" );
                $altMsgElement = $record->getField( "{$methodPrefix}xmlAltMsg" );

                $prefixAndMsgElement = explode(":", $altMsgElement);

                $authRequired = ($methodAuthSelection == 'Run script with username/password from web service SOAP header');

                if ($authRequired && !isset( $authSchema )) {
                    $prefix = 'tns';
                    $authTypeName = $wsm->getProperty( 'authType' );
                    $authSchema = new MySchema( $namespace, $prefix );

                    $authComplexAttributes [] = array (
                        'name' => 'username',
                        'type' => 'xsd:string'
                    );
                    $authComplexAttributes [] = array (
                        'name' => 'password',
                        'type' => 'xsd:string'
                    );

                    $authType = new ComplexType( $authTypeName, $authComplexAttributes );
                    $authSimpleAttributes = array (
                        'name' => $authTypeName,
                        'type' => "$prefix:$authTypeName"
                    );

                    $authElement = new SimpleElement( 'element', $authSimpleAttributes );
                    $authSchema->addChildDoc( $authElement );
                    $authSchema->addChildDoc( $authType );

                    $authMsg = new AuthenticationMessage( $authTypeName, $prefix );
                    if (count( $msgArray )) {
                        array_unshift( $msgArray, $authMsg );
                    } else {
                        $msgArray [] = $authMsg;
                    }

                    if (count( $schemaArray )) {
                        array_unshift( $schemaArray, $authSchema );
                    } else {
                        $schemaArray [] = $authSchema;
                    }
                }

                $host = WebServiceManagerDB::host;
                if (empty( $username )) {
                    $username = NULL;
                } elseif (empty( $password )) {
                    $password = NULL;
                }

                $fm = new FileMaker( $fileName, $host, $username, $password );
                $fmLayout = $fm->getLayout( $layout );
                //WebServiceManagerDB::checkError( $fmLayout, "whatever" );
                WebServiceManagerDB::checkError( $fmLayout, "getting the elements on layout '$layout' from file '$fileName' on host '$host' with username '$username'. Go to the Web Services Manager database and make sure that the username and password set for file '$fileName' is a valid account with both the FMXML and FMPHP extended privileges enabled. If this is the wrong account, use the 'Edit Auth Info' button on operations page to change it" );
                if (FileMaker::isError( $fmLayout )) {
                    $fmMsg = $fmLayout->getMessage();
                    $fmCode = $fmLayout->getCode();
                    $secondaryMessage = "$fmCode $fmMsg";
                    $message = "Authentication failed for file '$fileName' with username '$username' on '$host'. " . "Go to the Web Services Manager database and make sure the correct username and password is set for this file<br />" . $secondaryMessage;
                    Logger::getLogger()->genericLog( $message );
                    die( $message );
                }

                $xmlLayout = WSDL::formatXMLTag( $layout );

                //if ($returnFirstRecord) {
                //	$minOccurs = '1';
                //	$maxOccurs = '1';
                //} else {
                //	$minOccurs = '0';
                //	$maxOccurs = 'unbounded';
                //}
                $minOccurs = '1';
                $maxOccurs = '1';

                $customXml = html_entity_decode(trim($xmlSchema), ENT_COMPAT, "UTF-8");
                if ($isUsingXmlSchema && preg_match('/^<.*schema.*<\/.*schema>$/s', $customXml) == 1) {
                    Logger::getLogger()->genericLog("Using custom schema");
                    $documentFragment = $types->createDocumentFragment();
                    $documentFragment->appendXML($customXml);
                    $e = libxml_get_last_error();
                    $errorMessage = "The following error occurred while trying to read a custom schema for the $methodName operation: {$e->message} ({$e->code})";
                    WebServiceManagerDB::checkLibXmlError($e, $errorMessage);
                    $types->documentElement->appendChild( $documentFragment );
                    $e = libxml_get_last_error();
                    $errorMessage = "The following error occurred while trying to read a custom schema for the $methodName operation: {$e->message} ({$e->code})";
                    WebServiceManagerDB::checkLibXmlError($e, $errorMessage);
                } else if($isUsingXmlSchema) {
                    Logger::getLogger()->genericLog("Using custom schema fragment");
                    $documentFragment = $schema->createDocumentFragment();
                    $documentFragment->appendXML($customXml);
                    $e = libxml_get_last_error();
                    $errorMessage = "The following error occurred while trying to read a custom schema fragment for the $methodName operation: {$e->message} ({$e->code})";
                    WebServiceManagerDB::checkLibXmlError($e, $errorMessage);
                    $schema->documentElement->appendChild( $documentFragment );
                    $e = libxml_get_last_error();
                    $errorMessage = "The following error occurred while trying to read a custom schema fragment for the $methodName operation: {$e->message} ({$e->code})";
                    WebServiceManagerDB::checkLibXmlError($e, $errorMessage);
                } else {
                    $parameterRecords = $wsm->getParameterRecords( $methodName );
                    $parameterElements = getParameterElements( $parameterRecords );
                    $schema->addChildDoc( new ElementAndComplexType( $methodName, $parameterElements ) );
                }

                $xmlAltMsg = $record->getField($methodPrefix . 'xmlAltMsg');
                $methodName = $record->getField($methodPrefix . 'methodName');
                if($isUsingXmlSchema && strlen($xmlAltMsg) > 0) {
                    $explode = explode(':', $xmlAltMsg, 2);
                    $cacheMethodName = $explode[1];
                } else {
                    $cacheMethodName = $methodName;
                }

                $operation = array (
                    'expiration' => $wsm->getExpiration(),
                    'methodName' => $methodName,
                    'methodDocs' => $record->getField( $methodPrefix . 'methodDocs' ),
                    'methodAuthSelection' => $record->getField( $methodPrefix . 'methodAuthSelection' ),
                    'layoutName' => $record->getField( $methodPrefix . 'layoutName' ),
                    'returnFirstRecord' => $record->getField( $methodPrefix . 'returnFirstRecord' ),
                    'fileName' => $record->getField( $filePrefix . 'fileName' ),
                    'fileAlias' => $record->getField( $filePrefix . 'alias' ),
                    'userName' => $record->getField( $filePrefix . 'userName' ),
                    'password' => $record->getField( $filePrefix . 'password' ),
                    'maxRecords' => $record->getField( $methodPrefix . 'maxRecords' ),
                    'getParamsByName' => $record->getField( $methodPrefix . 'getParamsByName' ),
                    'scriptNameCalc' => $record->getField( $methodPrefix . 'scriptNameCalc' ),
                    'ns' => $namespace,
                    'isUsingXmlSchema' => $record->getField( $methodPrefix . 'isUsingXmlSchema' ),
                    'parameters' => $parameterRecords
                );

                $operationCache = strtolower( $cacheMethodName ) . '.cache';
                writeOperationCache( serialize( $operation ), $operationCache );

                $responseElementAttributes = NULL;

                $responseElementName = $methodName . 'Response';
                $resultElementName = $methodName . 'Result';

                $wrapperOrArray = NULL;
                $fieldElements = getFieldElements( $fmLayout );

                $portalElementArray = NULL;
                $portalElements = getPortalElements( $fmLayout );
                if (isset( $portalElements )) {
                    foreach ( $portalElements as $portalName => $portalArray ) {
                        if (!in_array( $portalName, $portalTypeArray )) {
                            $fieldElements [] = array (
                                'name' => $portalName,
                                'type' => "$namespacePrefix:$portalName",
                                'maxOccurs' => 'unbounded'
                            );
                            $portalResponseElement = new ComplexType( $portalName, $portalArray );
                            $schema->addChildDoc( $portalResponseElement );
                            $portalTypeArray [] = $portalName;
                        }
                    }
                }

                if (!in_array( $xmlLayout, $layoutTypeArray )) {
                    $layoutComplexType = new ComplexType( $xmlLayout, $fieldElements );
                    $schema->addChildDoc( $layoutComplexType );
                    $layoutTypeArray [] = $xmlLayout;
                }

                //Adding support for 'ArrayOf...' when returning multiple elements. This is needed by Flash, which always expects there to be a meaningless outer wrapper, followed by exactly one element. --jsb	
                if (!$returnFirstRecord) {
                    $typeName = "ArrayOf${xmlLayout}";
                    if (!in_array( $typeName, $layoutTypeArray )) {
                        $maxRecords = $operation['maxRecords'];
                        $arrayOfElement[0] = array (
                            'name' => $xmlLayout,
                            'type' => "$namespacePrefix:$xmlLayout",
                            'minOccurs' => '0',
                            'maxOccurs' => !empty($maxRecords) ? $maxRecords : 'unbounded'
                        );
                        $arrayComplexType = new ComplexType( 'ArrayOf' . $xmlLayout, $arrayOfElement );
                        $schema->addChildDoc( $arrayComplexType );

                        $layoutTypeArray [] = $typeName;
                    }
                }

                foreach ( $portalElementArray as $element ) {
                    $schema->addChildDoc( $portalResponseElement );
                }

                if ($returnFirstRecord) {
                    $wrapperOrArray [] = array (
                        'name' => $xmlLayout,
                        'minOccurs' => $minOccurs,
                        'maxOccurs' => $maxOccurs,
                        'type' => "$namespacePrefix:$xmlLayout"
                    );
                } else {
                    $wrapperOrArray [] = array (
                        'name' => 'ArrayOf' . $xmlLayout,
                        'minOccurs' => $minOccurs,
                        'maxOccurs' => $maxOccurs,
                        'type' => "$namespacePrefix:ArrayOf$xmlLayout"
                    );
                }
                $schema->addChildDoc( new ElementAndComplexType( $responseElementName, $wrapperOrArray ) );

                if (count($prefixAndMsgElement) == 2) {
                    $msgArray [] = new RequestMessage($methodName, $namespacePrefix, $prefixAndMsgElement[1], $prefixAndMsgElement[0]);
                } else {
                    $msgArray [] = new RequestMessage($methodName, $namespacePrefix);
                }
                $msgArray [] = new ResponseMessage( $responseElementName, $namespacePrefix );
            }
            $schemaArray [] = $schema;
            $i++;
        }

        $bindingArray = NULL;
        $portTypeArray = NULL;
        $servicePortArray = NULL;
        $serviceArray = NULL;

        foreach ( $serviceToMethodRecords as $serviceName => $methodRecords ) {
            $serviceDocs = $methodRecords ['serviceDocs'];
            unset( $methodRecords ['serviceDocs'] );
            //        if (count($serviceToMethodRecords) == 1) {
            $service = new Service( $serviceName, $serviceDocs );
            /*} else {
            $service = new Service('AllMyServices');
        }*/
            $servicePort = new ServicePort( $serviceName, 'tns', $serverName );
            $portType = new PortType( $serviceName/*, 'blah'*/);
            $binding = new Binding( $serviceName, 'tns'/*, 'blah'*/);

            foreach ( $methodRecords as $record ) {

                $methodName = ucfirst( $record->getField( $methodPrefix . 'methodName' ) );
                $methodDocs = $record->getField( $methodPrefix . 'methodDocs' );
                $methodAuthSelection = $record->getField( $methodPrefix . 'methodAuthSelection' );

                $authRequired = ($methodAuthSelection == 'Run script with username/password from web service SOAP header');
                $authTypeName = $wsm->getProperty( 'authType' );

                $portTypeOp = new PortTypeOperation( $methodName, NULL, empty( $methodDocs ) ? NULL : $methodDocs );
                $portType->addChildDoc( $portTypeOp );

                $bindingOp = new BindingOperation( $methodName, $authRequired, $authTypeName, 'tns'/*, NS_URL . '/' . WSDL::formatXMLTag($methodName)*/);
                $binding->addChildDoc( $bindingOp );
            }
            $bindingArray [] = $binding;
            $portTypeArray [] = $portType;
            $service->addChildDoc( $servicePort );
            $serviceArray [] = $service;
        }

        foreach ( $schemaArray as $sch ) {
            $types->addChildDoc( $sch );
        }

        $wsdl->addChildDoc( $types );

        foreach ( $msgArray as $msg ) {
            $wsdl->addChildDoc( $msg );
        }

        foreach ( $ns as $name => $value ) {
            $wsdl->$name = $value;
        }

        foreach ( $portTypeArray as $port ) {
            $wsdl->addChildDoc( $port );
        }

        foreach ( $bindingArray as $bind ) {
            $wsdl->addChildDoc( $bind );
        }

        /*    foreach ($servicePortArray as $sPort) {
            $service->addChildDoc($sPort);
        }*/

        foreach ( $serviceArray as $service ) {
            $wsdl->addChildDoc( $service );
        }

        //    $wsdl->addChildDoc($service);


        try {
            $wsdl->write();
        } catch ( DOMException $e ) {
            Logger::getLogger()->genericLog( $e->getMessage() . PHP_EOL . $e->getTraceAsString() );
            header( 'Content-type: text/html', TRUE, 500 );
            echo '<html><body>';
            echo "<p>" . str_replace( "\n", "</p>\n<p>", $e->getMessage() ) . '</p>';
            if ($e->getCode()) {
                echo "<p>Error code: {$e->getCode()}</p>";
            }
            echo '</p></body></html>';
            exit();
        }
    } elseif (array_key_exists( 'wsmaction', $get )) {
        $user = NULL;
        $pass = NULL;

        if (array_key_exists( 'username', $get )) {
            $user = $get ['username'];
        }

        if (array_key_exists( 'password', $get )) {
            $pass = $get ['password'];
        }

        $parsedQueryString = arrayRemoveKey( $get, 'username', 'password', 'wsmaction', 'use_remote', 'original_url', 'send_sess_end' );
        if ($get ['wsmaction'] == 'wsmaction') {
            WebServiceManagerDB::accessXMLGateway( $user, $pass, $parsedQueryString );
        } else {
            WebServiceManagerDB::accessXMLGateway( $user, $pass, $parsedQueryString, 'FMPXMLRESULT.xml' );
        }
    } else {
        libxml_clear_errors();

        $fmMethod = new FileMakerMethod( );

        if (array_key_exists( 'test', $_REQUEST )) {
            $postData = <<<POSTDATA
<?xml version="1.0" encoding="UTF-8"?>
<Envelope xmlns="http://schemas.xmlsoap.org/soap/envelope/">
  <Body>
    <ns2:HelloWorld xmlns="http://127.0.0.1" xmlns:ns2="http://127.0.0.1/WSMExamples"/>
  </Body>
</Envelope>
POSTDATA;
        } else {
            $postData = file_get_contents( 'php://input' ); //preferred method for reading raw post data
        }

        //Log raw post data for debugging purposes
        Logger::getLogger()->genericLog( 'Raw XML request: ' . $postData );

        //Log XML-formatted post data
        Logger::getLogger()->requestLog( $postData );

        $xmlParser = new Xml2Assoc( );
        $postArray = $xmlParser->parseString( $postData, TRUE );

        $authArray = $postArray ['Envelope'] ['Header'] ['AuthenticatedUser'];

        if (isset( $authArray )) {
            $fmMethod->AuthenticatedUser( $authArray );
        }

        $methParamArray = $postArray ['Envelope'] ['Body'];

        if (isset( $methParamArray )) {
            foreach ( $methParamArray as $methodName => $parameter ) {
                $fmMethod->callScript( $methodName, $parameter, $postData );
                break;
            }
        }
    }
} catch ( DOMException $e ) {
    $errorMsg = WSDL::formatXMLContent( $e->getMessage() );
    try {
        throw new SoapFaultException( $errorMsg, 'Client' );
    } catch ( SoapFaultException $e ) {
        die( $e );
    }
} catch ( SoapFaultException $e ) {
    Logger::getLogger()->genericLog( $e->getMessage() );
    Logger::getLogger()->responseLog( $e );
    die( $e );
} catch ( ErrorException $e ) {
    Logger::getLogger()->genericLog( $e->getMessage() . PHP_EOL . $e->getTraceAsString() );
    header( 'Content-type: text/html', TRUE, 500 );
    echo '<html><body>';
    echo "<p>" . str_replace( "\n", "</p>\n<p>", $e->getMessage() ) . '</p>';
    if ($e->getCode()) {
        echo "<p>Error code: {$e->getCode()}</p>";
    }
    echo '</p></body></html>';
}

/***********************END OF MAIN***********************/

/***********************START OF HELPER FUNCTIONS***********************/

function readOperationCache($filename) {
    $fileToRead = join_path(TEMP_DIR, basename(__FILE__, ".php") . "_$filename");
    $return = file_get_contents( $fileToRead );
    if (!$return) {
        $errors = error_get_last();
        Logger::getLogger()->genericLog( "Unable to retrieve cache file from $fileToRead. " . $errors ['message'] );
    } else {
        Logger::getLogger()->genericLog( "Retrieved cache file from $fileToRead" );
    }
    return $return;
}

function writeOperationCache($content, $filename) {

    $fileToWrite = join_path(TEMP_DIR, basename(__FILE__, ".php") . "_$filename");
    $return = file_put_contents($fileToWrite, $content, LOCK_EX);
    if (!$return) {
        $errors = error_get_last();
        Logger::getLogger( "Unable to write cache file to $fileToWrite. " . $errors ['message'] );
    } else {
        Logger::getLogger()->genericLog( "Wrote cache file to $fileToWrite" );
    }
    return $return;
}

function deleteOperationCache($filename) {

    $fileToDelete = join_path(TEMP_DIR, $filename);
    if (file_exists( $fileToDelete )) {
        unlink( $fileToDelete );
    }
}

function errorExceptionErrorHandler($errno, $errstr) {

    throw new ErrorException( $errstr, $errno );
}

function fatalErrorHandler() {

    if ($error = error_get_last()) {
        if (isset( $error ['type'] ) && ($error ['type'] === E_ERROR || $error ['type'] === E_PARSE || $error ['type'] === E_COMPILE_ERROR)) {
            header( 'Content-type: text/html', TRUE, 500 );
            if (ob_get_level() !== 0) {
                ob_end_clean();
            }
            Logger::getLogger()->genericLog( $error ['message'] . PHP_EOL );
            echo '<html><body>';
            echo "<p>" . str_replace( "\n", "</p>\n<p>", $error ['message'] ) . '</p>';
            echo '</body></html>';
        }
    }
}

function getFieldElements(FileMaker_Layout $lay) {

    $typeArray = array (
        'text' => 'string',
        'number' => 'decimal',
        'date' => 'date',
        'time' => 'time',
        'timestamp' => 'dateTime',
        'container' => 'base64Binary'
    );

    $fields = $lay->getFields();

    $fieldWrapper = array ();
    $fieldArray = array ();

    //    $naCounter = 1;
    foreach ( $fields as $fieldName => $fieldValue ) {
        if (empty( $fieldName )) {
            $fieldArray ['name'] = "NoAccess";
            $fieldArray ['type'] = 'xsd:string';
            $fieldArray ['maxOccurs'] = 'unbounded';
            /*if ($naCounter > 1) {
                $fieldArray['maxOccurs'] = $naCounter;
            }
            $naCounter ++;*/
        } else {
            $fieldArray ['name'] = WSDL::formatXMLTag( $fieldName );
            $fieldArray ['type'] = 'xsd:' . $typeArray [$fieldValue->getResult()];
            $rules = $fieldValue->describeValidationRules();
            $fieldArray ['nillable'] = $rules[FILEMAKER_RULE_NOTEMPTY] ? 'false' : 'true';
        }
        $fieldWrapper [] = $fieldArray;
    }
    return $fieldWrapper;
}

function getPortalElements(FileMaker_Layout $lay) {

    $typeArray = array (
        'text' => 'string',
        'number' => 'decimal',
        'date' => 'date',
        'time' => 'time',
        'timestamp' => 'dateTime',
        'container' => 'base64Binary'
    );
    $portals = $lay->getRelatedSets();
    if (!FileMaker::isError( $portals )) {
        $fieldWrapper = NULL;

        foreach ( $portals as $portalName => $portalRecord ) {
            $fields = $portalRecord->getFields();
            $fieldArray = NULL;

            //            $naCounter = 1;
            foreach ( $fields as $fieldName => $fieldValue ) {
                if (empty( $fieldName )) {
                    $fieldArray ['name'] = "NoAccess";
                    $fieldArray ['type'] = 'xsd:string';
                    $fieldArray ['maxOccurs'] = 'unbounded';
                    /*if ($naCounter > 1) {
                        $fieldArray['maxOccurs'] = $naCounter;
                    }
                    $naCounter ++;*/
                } else {
                    $formattedFieldName = WSDL::formatXMLTag( $fieldName );
                    $portalPrefix = WSDL::formatXMLTag( $portalName . "__" );
                    if (strpos( $formattedFieldName, $portalPrefix ) === 0) {
                        $count = 1;
                        $formattedFieldName = str_replace( $portalPrefix, "", $formattedFieldName, $count );
                    }
                    $fieldArray ['name'] = $formattedFieldName;
                    $fieldArray ['type'] = 'xsd:' . $typeArray [$fieldValue->getResult()];
                    $rules = $fieldValue->describeValidationRules();
                    $fieldArray ['nillable'] = $rules[FILEMAKER_RULE_NOTEMPTY] ? 'false' : 'true';
                }
                $fieldWrapper [WSDL::formatXMLTag( $portalName )] [] = $fieldArray;
            }
        }
    }
    return $fieldWrapper;
}

function getParameterElements($parameterRecords) {

    $typeArray = array (
        'text' => 'string',
        'number' => 'decimal',
        'date' => 'date',
        'time' => 'time',
        'timestamp' => 'dateTime',
        'container' => 'base64Binary'
    );
    $parameterWrapper = array ();
    $parameterArray = array ();
    foreach ( $parameterRecords as $record ) {
        $parameterArray ['name'] = WSDL::formatXMLTag( $record->getField( 'Parameter::parameterName' ) );
        $parameterArray ['type'] = 'xsd:' . $typeArray [$record->getField( 'Parameter::parameterType' )];
        $parameterWrapper [] = $parameterArray;
    }
    return $parameterWrapper;
}

function arrayRemoveKey() {

    $args = func_get_args();
    $arr = $args [0];
    $keys = array_slice( $args, 1 );
    foreach ( $arr as $k => $v ) {
        if (in_array( $k, $keys )) {
            unset( $arr [$k] );
        }
        if (strpos( $k, "debug" ) !== FALSE) {
            unset( $arr [$k] );
        }
    }
    return $arr;
}

function arrayRemoveValue() {

    $args = func_get_args();
    $arr = $args [0];
    $values = array_slice( $args, 1 );
    foreach ( $arr as $k => $v ) {
        if (in_array( $v, $values ))
            unset( $arr [$k] );
    }
    return $arr;
}

function generate_soap_fault_payload($faultCode, $faultString) {

    header( 'Content-type:text/xml;charset=utf-8', true, 500 );
    $soapFaultXML = <<<SOAPFAULT
<?xml version="1.0" encoding="UTF-8"?>
<Envelope xmlns="http://schemas.xmlsoap.org/soap/envelope/">
    <Body xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
        <SOAP-ENV:Fault xmlns="">
            <faultcode>SOAP-ENV:$faultCode</faultcode>
            <faultstring>$faultString</faultstring>
        </SOAP-ENV:Fault>
    </Body>
</Envelope>
SOAPFAULT;
    return $soapFaultXML;
}

function soap_request_error_handler() {

    $lastError = error_get_last();
    $xmlResponseOutput = NULL;
    if ($lastError) {
        $soapFaultXML = <<<SOAPFAULT
<?xml version="1.0" encoding="UTF-8"?>
<Envelope xmlns="http://schemas.xmlsoap.org/soap/envelope" xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/">
<Body>
<SOAP-ENV:Fault xmlns="">
<faultcode>SOAP-ENV:Client</faultcode>
<faultstring>Invalid SOAP Request: {$lastError['message']}</faultstring>
</SOAP-ENV:Fault>
</Body>
</Envelope>
SOAPFAULT;
        $xmlDoc = new DOMDocument( '1.0', 'utf-8' );
        $xmlDoc->loadXML( $soapFaultXML );
        $xmlDoc->formatOutput = TRUE;
        $xmlDoc->preserveWhiteSpace = FALSE;
        $xmlResponseOutput = $xmlDoc->saveXML();
        Logger::getLogger()->responseLog( $xmlResponseOutput );
        Logger::getLogger()->genericLog( 'Invalid SOAP Request: ' . $lastError ['message'] );
    }
    return $xmlResponseOutput;
}

if (!function_exists( 'sys_get_temp_dir' )) {

    function sys_get_temp_dir() {

        $returnValue = FALSE;
        if (!empty( $_ENV ['TMP'] )) {
            $returnValue = realpath( $_ENV ['TMP'] );
        } elseif (!empty( $_ENV ['TMPDIR'] )) {
            $returnValue = realpath( $_ENV ['TMPDIR'] );
        } elseif (!empty( $_ENV ['TEMP'] )) {
            $returnValue = realpath( $_ENV ['TEMP'] );
        } else {
            $tempfile = tempnam( uniqid( rand(), TRUE ), '' );
            if (file_exists( $tempfile )) {
                unlink( $tempfile );
                $returnValue = realpath( dirname( $tempfile ) );
            }
        }
        return $returnValue;
    }
}

function join_path()
{
    $num_args = func_num_args();
    $args = func_get_args();
    $path = $args[0];

    if( $num_args > 1 )
    {
        for ($i = 1; $i < $num_args; $i++)
        {
            $path .= DIRECTORY_SEPARATOR.$args[$i];
        }
    }

    return $path;
}

/***********************END OF HELPER FUNCTIONS***********************/

?>